"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends4 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _theme = require("../../theme");

var genBaseStyle = function genBaseStyle(token) {
  var _extends2, _extends3;

  var antCls = token.antCls,
      componentCls = token.componentCls,
      iconCls = token.iconCls,
      avatarBg = token.avatarBg,
      avatarColor = token.avatarColor,
      avatarSizeBase = token.avatarSizeBase,
      avatarSizeLG = token.avatarSizeLG,
      avatarSizeSM = token.avatarSizeSM,
      avatarFontSizeBase = token.avatarFontSizeBase,
      avatarFontSizeLG = token.avatarFontSizeLG,
      avatarFontSizeSM = token.avatarFontSizeSM,
      avatarBorderRadius = token.avatarBorderRadius,
      lineWidth = token.lineWidth,
      lineType = token.lineType; // Avatar size style

  var avatarSizeStyle = function avatarSizeStyle(size, fontSize) {
    var _ref;

    return _ref = {
      width: size,
      height: size,
      lineHeight: "".concat(size - lineWidth * 2, "px"),
      borderRadius: '50%'
    }, (0, _defineProperty2["default"])(_ref, "".concat(componentCls, "-string"), {
      position: 'absolute',
      left: {
        _skip_check_: true,
        value: '50%'
      },
      transformOrigin: '0 center'
    }), (0, _defineProperty2["default"])(_ref, "&".concat(componentCls, "-icon"), (0, _defineProperty2["default"])({
      fontSize: fontSize
    }, "> ".concat(iconCls), {
      margin: 0
    })), _ref;
  };

  return (0, _defineProperty2["default"])({}, componentCls, (0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    position: 'relative',
    display: 'inline-block',
    overflow: 'hidden',
    color: avatarColor,
    whiteSpace: 'nowrap',
    textAlign: 'center',
    verticalAlign: 'middle',
    background: avatarBg,
    border: "".concat(lineWidth, "px ").concat(lineType, " transparent")
  }, (0, _defineProperty2["default"])(_extends2, "&-image", {
    background: 'transparent'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(antCls, "-image-img"), {
    display: 'block'
  }), _extends2)), avatarSizeStyle(avatarSizeBase, avatarFontSizeBase)), (_extends3 = {}, (0, _defineProperty2["default"])(_extends3, "&-lg", (0, _extends4["default"])({}, avatarSizeStyle(avatarSizeLG, avatarFontSizeLG))), (0, _defineProperty2["default"])(_extends3, "&-sm", (0, _extends4["default"])({}, avatarSizeStyle(avatarSizeSM, avatarFontSizeSM))), (0, _defineProperty2["default"])(_extends3, "&-square", {
    borderRadius: avatarBorderRadius
  }), (0, _defineProperty2["default"])(_extends3, '> img', {
    display: 'block',
    width: '100%',
    height: '100%',
    objectFit: 'cover'
  }), _extends3)));
};

var genGroupStyle = function genGroupStyle(token) {
  var _$concat3;

  var componentCls = token.componentCls,
      avatarGroupBorderColor = token.avatarGroupBorderColor,
      avatarGroupOverlapping = token.avatarGroupOverlapping,
      avatarGroupSpace = token.avatarGroupSpace;
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-group"), (_$concat3 = {
    display: 'inline-flex'
  }, (0, _defineProperty2["default"])(_$concat3, "".concat(componentCls), (0, _defineProperty2["default"])({
    borderColor: avatarGroupBorderColor
  }, "&:not(:first-child)", {
    marginInlineStart: -avatarGroupOverlapping
  })), (0, _defineProperty2["default"])(_$concat3, "&-popover", (0, _defineProperty2["default"])({}, "".concat(componentCls, " + ").concat(componentCls), {
    marginInlineStart: avatarGroupSpace
  })), _$concat3));
};

var _default = (0, _theme.genComponentStyleHook)('Avatar', function (token) {
  var colorTextLightSolid = token.colorTextLightSolid,
      controlHeight = token.controlHeight,
      controlHeightLG = token.controlHeightLG,
      controlHeightSM = token.controlHeightSM,
      fontSize = token.fontSize,
      fontSizeLG = token.fontSizeLG,
      fontSizeXL = token.fontSizeXL,
      fontSizeHeading3 = token.fontSizeHeading3,
      marginXS = token.marginXS,
      colorBorderBg = token.colorBorderBg,
      colorTextPlaceholder = token.colorTextPlaceholder;
  var avatarToken = (0, _theme.mergeToken)(token, {
    avatarBg: colorTextPlaceholder,
    avatarColor: colorTextLightSolid,
    avatarSizeBase: controlHeight,
    avatarSizeLG: controlHeightLG,
    avatarSizeSM: controlHeightSM,
    avatarFontSizeBase: Math.round((fontSizeLG + fontSizeXL) / 2),
    avatarFontSizeLG: fontSizeHeading3,
    avatarFontSizeSM: fontSize,
    avatarBorderRadius: token.radiusBase,
    avatarGroupOverlapping: marginXS,
    avatarGroupSpace: marginXS,
    avatarGroupBorderColor: colorBorderBg
  });
  return [genBaseStyle(avatarToken), genGroupStyle(avatarToken)];
});

exports["default"] = _default;