"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _theme = require("../../theme");

var genBreadcrumbStyle = function genBreadcrumbStyle(token) {
  var _extends2;

  var componentCls = token.componentCls,
      iconCls = token.iconCls;
  return (0, _defineProperty2["default"])({}, componentCls, (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    color: token.breadcrumbBaseColor,
    fontSize: token.breadcrumbFontSize
  }, (0, _defineProperty2["default"])(_extends2, iconCls, {
    fontSize: token.breadcrumbIconFontSize
  }), (0, _defineProperty2["default"])(_extends2, "ol", {
    display: 'flex',
    flexWrap: 'wrap',
    margin: 0,
    padding: 0,
    listStyle: 'none'
  }), (0, _defineProperty2["default"])(_extends2, "a", {
    color: token.breadcrumbLinkColor,
    transition: "color ".concat(token.motionDurationSlow),
    '&:hover': {
      color: token.breadcrumbLinkColorHover
    }
  }), (0, _defineProperty2["default"])(_extends2, 'li:last-child', {
    color: token.breadcrumbLastItemColor,
    a: {
      color: token.breadcrumbLastItemColor
    }
  }), (0, _defineProperty2["default"])(_extends2, "li:last-child ".concat(componentCls, "-separator"), {
    display: 'none'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-separator"), {
    marginInline: token.breadcrumbSeparatorMargin,
    color: token.breadcrumbSeparatorColor
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-link"), (0, _defineProperty2["default"])({}, "\n        > ".concat(iconCls, " + span,\n        > ").concat(iconCls, " + a\n       "), {
    marginInlineStart: token.marginXXS
  })), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-overlay-link"), (0, _defineProperty2["default"])({}, "> ".concat(iconCls), {
    marginInlineStart: token.marginXXS
  })), (0, _defineProperty2["default"])(_extends2, "&".concat(token.componentCls, "-rtl"), {
    direction: 'rtl'
  }), _extends2)));
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Breadcrumb', function (token) {
  var BreadcrumbToken = (0, _theme.mergeToken)(token, {
    breadcrumbBaseColor: token.colorTextSecondary,
    breadcrumbFontSize: token.fontSizeBase,
    breadcrumbIconFontSize: token.fontSizeBase,
    breadcrumbLinkColor: token.colorTextSecondary,
    breadcrumbLinkColorHover: token.colorText,
    breadcrumbLastItemColor: token.colorText,
    breadcrumbSeparatorMargin: token.paddingXS,
    breadcrumbSeparatorColor: token.colorTextSecondary
  });
  return [genBreadcrumbStyle(BreadcrumbToken)];
});

exports["default"] = _default;