"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _style = require("../../checkbox/style");

var _theme = require("../../theme");

// deps-lint-skip-all
// =============================== Base ===============================
var genBaseStyle = function genBaseStyle(token) {
  var _item;

  var prefixCls = token.prefixCls,
      componentCls = token.componentCls;
  var cascaderMenuItemCls = "".concat(componentCls, "-menu-item");
  var iconCls = "\n    &".concat(cascaderMenuItemCls, "-expand ").concat(cascaderMenuItemCls, "-expand-icon,\n    ").concat(cascaderMenuItemCls, "-loading-icon\n  ");
  var itemPaddingVertical = Math.round((token.controlHeight - token.fontSize * token.lineHeight) / 2);
  return [// =====================================================
  // ==                     Control                     ==
  // =====================================================
  (0, _defineProperty2["default"])({}, componentCls, {
    width: token.controlWidth
  }), // =====================================================
  // ==                      Popup                      ==
  // =====================================================
  (0, _defineProperty2["default"])({}, "".concat(componentCls, "-dropdown"), [// ==================== Checkbox ====================
  (0, _style.getStyle)("".concat(prefixCls, "-checkbox"), token), (0, _defineProperty2["default"])({}, componentCls, {
    // ================== Checkbox ==================
    '&-checkbox': {
      top: 0,
      marginInlineEnd: token.paddingXS
    },
    // ==================== Menu ====================
    // >>> Menus
    '&-menus': (0, _defineProperty2["default"])({
      display: 'flex',
      flexWrap: 'nowrap',
      alignItems: 'flex-start'
    }, "&".concat(componentCls, "-menu-empty"), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-menu"), (0, _defineProperty2["default"])({
      width: '100%',
      height: 'auto'
    }, cascaderMenuItemCls, {
      color: token.colorTextDisabled,
      cursor: 'default',
      pointerEvents: 'none'
    }))),
    // >>> Menu
    '&-menu': {
      flexGrow: 1,
      minWidth: token.controlItemWidth,
      height: token.dropdownHeight,
      margin: "-".concat(token.paddingXS, "px 0"),
      padding: "".concat(token.paddingXS, "px 0"),
      overflow: 'auto',
      verticalAlign: 'top',
      listStyle: 'none',
      borderInlineEnd: "".concat(token.controlLineWidth, "px ").concat(token.controlLineType, " ").concat(token.colorSplit),
      '-ms-overflow-style': '-ms-autohiding-scrollbar',
      '&-item': (_item = {
        display: 'flex',
        flexWrap: 'nowrap',
        alignItems: 'center',
        padding: "".concat(itemPaddingVertical, "px ").concat(token.paddingSM, "px"),
        overflow: 'hidden',
        lineHeight: token.lineHeight,
        whiteSpace: 'nowrap',
        textOverflow: 'ellipsis',
        cursor: 'pointer',
        transition: "all ".concat(token.motionDurationSlow),
        '&:hover': {
          background: token.controlItemBgHover
        },
        ' &-disabled': (0, _defineProperty2["default"])({
          color: token.colorTextDisabled,
          cursor: 'not-allowed',
          '&:hover': {
            background: 'transparent'
          }
        }, iconCls, {
          color: token.colorTextDisabled
        })
      }, (0, _defineProperty2["default"])(_item, "&-active:not(".concat(cascaderMenuItemCls, "-disabled)"), (0, _defineProperty2["default"])({}, "&, &:hover", {
        fontWeight: token.fontWeightStrong,
        backgroundColor: token.controlItemBgActive
      })), (0, _defineProperty2["default"])(_item, '&-content', {
        flex: 'auto'
      }), (0, _defineProperty2["default"])(_item, iconCls, {
        marginInlineStart: token.paddingXXS,
        color: token.colorTextSecondary,
        fontSize: token.fontSizeIcon
      }), (0, _defineProperty2["default"])(_item, '&-keyword', {
        color: token.colorHighlight
      }), _item)
    }
  })]), // =====================================================
  // ==                       RTL                       ==
  // =====================================================
  (0, _defineProperty2["default"])({}, "".concat(componentCls, "-dropdown-rtl"), {
    direction: 'rtl'
  })];
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Cascader', function (token) {
  return [genBaseStyle(token)];
}, {
  controlWidth: 184,
  controlItemWidth: 111,
  dropdownHeight: 180
});

exports["default"] = _default;