"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.genBaseStyle = exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _theme = require("../../theme");

var genBaseStyle = function genBaseStyle(token) {
  var _$concat, _$concat4, _$concat5, _extends2;

  var componentCls = token.componentCls,
      collapseContentBg = token.collapseContentBg,
      collapseContentPadding = token.collapseContentPadding,
      collapseHeaderBg = token.collapseHeaderBg,
      collapseHeaderPadding = token.collapseHeaderPadding,
      collapsePanelBorderRadius = token.collapsePanelBorderRadius,
      controlLineWidth = token.controlLineWidth,
      controlLineType = token.controlLineType,
      colorBorder = token.colorBorder,
      colorText = token.colorText,
      colorTextHeading = token.colorTextHeading,
      colorTextDisabled = token.colorTextDisabled,
      fontSize = token.fontSize,
      lineHeight = token.lineHeight,
      marginSM = token.marginSM,
      paddingSM = token.paddingSM,
      motionDurationSlow = token.motionDurationSlow;
  var borderBase = "".concat(controlLineWidth, "px ").concat(controlLineType, " ").concat(colorBorder);
  return (0, _defineProperty2["default"])({}, componentCls, (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    backgroundColor: collapseHeaderBg,
    border: borderBase,
    borderBottom: 0,
    borderRadius: "".concat(collapsePanelBorderRadius, "px")
  }, (0, _defineProperty2["default"])(_extends2, "&-rtl", {
    direction: 'rtl'
  }), (0, _defineProperty2["default"])(_extends2, "& > ".concat(componentCls, "-item"), (_$concat4 = {
    borderBottom: borderBase
  }, (0, _defineProperty2["default"])(_$concat4, "&:last-child", (0, _defineProperty2["default"])({}, "\n            &,\n            & > ".concat(componentCls, "-header"), {
    borderRadius: "0 0 ".concat(collapsePanelBorderRadius, "px ").concat(collapsePanelBorderRadius, "px")
  })), (0, _defineProperty2["default"])(_$concat4, "> ".concat(componentCls, "-header"), (_$concat = {
    position: 'relative',
    display: 'flex',
    flexWrap: 'nowrap',
    alignItems: 'flex-start',
    padding: collapseHeaderPadding,
    color: colorTextHeading,
    lineHeight: lineHeight,
    cursor: 'pointer',
    transition: "all ".concat(motionDurationSlow, ", visibility 0s"),
    '&:focus': {
      outline: 'none'
    }
  }, (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-expand-icon"), {
    height: fontSize * lineHeight,
    display: 'flex',
    alignItems: 'center',
    paddingInlineEnd: marginSM
  }), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-arrow"), (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetIcon)()), {
    svg: {
      transition: "transform ".concat(motionDurationSlow)
    }
  })), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-header-text"), {
    marginInlineEnd: 'auto'
  }), _$concat)), (0, _defineProperty2["default"])(_$concat4, "".concat(componentCls, "-header-collapsible-only"), (0, _defineProperty2["default"])({
    cursor: 'default'
  }, "".concat(componentCls, "-header-text"), {
    cursor: 'pointer'
  })), (0, _defineProperty2["default"])(_$concat4, "&".concat(componentCls, "-no-arrow"), (0, _defineProperty2["default"])({}, "> ".concat(componentCls, "-header"), {
    paddingInlineStart: paddingSM
  })), _$concat4)), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-content"), (_$concat5 = {
    color: colorText,
    backgroundColor: collapseContentBg,
    borderTop: borderBase
  }, (0, _defineProperty2["default"])(_$concat5, "& > ".concat(componentCls, "-content-box"), {
    padding: collapseContentPadding
  }), (0, _defineProperty2["default"])(_$concat5, "&-hidden", {
    display: 'none'
  }), _$concat5)), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-item:last-child"), (0, _defineProperty2["default"])({}, "> ".concat(componentCls, "-content"), {
    borderRadius: "0 0 ".concat(collapsePanelBorderRadius, "px ").concat(collapsePanelBorderRadius, "px")
  })), (0, _defineProperty2["default"])(_extends2, "& ".concat(componentCls, "-item-disabled > ").concat(componentCls, "-header"), (0, _defineProperty2["default"])({}, "\n          &,\n          & > .arrow\n        ", {
    color: colorTextDisabled,
    cursor: 'not-allowed'
  })), (0, _defineProperty2["default"])(_extends2, "&-ghost", (0, _defineProperty2["default"])({
    backgroundColor: 'transparent',
    border: 0
  }, "> ".concat(componentCls, "-item"), (0, _defineProperty2["default"])({
    borderBottom: 0
  }, "> ".concat(componentCls, "-content"), (0, _defineProperty2["default"])({
    backgroundColor: 'transparent',
    border: 0
  }, "> ".concat(componentCls, "-content-box"), {
    paddingBlock: paddingSM
  })))), (0, _defineProperty2["default"])(_extends2, "&".concat(componentCls, "-icon-position-end"), (0, _defineProperty2["default"])({}, "& > ".concat(componentCls, "-item"), (0, _defineProperty2["default"])({}, "> ".concat(componentCls, "-header"), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-expand-icon"), {
    order: 1,
    paddingInlineEnd: 0,
    paddingInlineStart: marginSM
  })))), _extends2)));
};

exports.genBaseStyle = genBaseStyle;

var genArrowStyle = function genArrowStyle(token) {
  var _ref2;

  var componentCls = token.componentCls;
  var fixedSelector = "> ".concat(componentCls, "-item > ").concat(componentCls, "-header ").concat(componentCls, "-arrow svg");
  return _ref2 = {}, (0, _defineProperty2["default"])(_ref2, "".concat(componentCls, "-icon-position-end, ").concat(componentCls, "-rtl"), (0, _defineProperty2["default"])({}, fixedSelector, {
    transform: "rotate(180deg)"
  })), (0, _defineProperty2["default"])(_ref2, "".concat(componentCls, "-rtl").concat(componentCls, "-icon-position-end"), (0, _defineProperty2["default"])({}, fixedSelector, {
    transform: "rotate(0deg)"
  })), _ref2;
};

var genBorderlessStyle = function genBorderlessStyle(token) {
  var _$concat12;

  var componentCls = token.componentCls,
      collapseHeaderBg = token.collapseHeaderBg,
      paddingXXS = token.paddingXXS,
      colorBorder = token.colorBorder;
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-borderless"), (_$concat12 = {
    backgroundColor: collapseHeaderBg,
    border: 0
  }, (0, _defineProperty2["default"])(_$concat12, "> ".concat(componentCls, "-item"), {
    borderBottom: "1px solid ".concat(colorBorder)
  }), (0, _defineProperty2["default"])(_$concat12, "\n        > ".concat(componentCls, "-item:last-child,\n        > ").concat(componentCls, "-item:last-child ").concat(componentCls, "-header\n      "), {
    borderRadius: 0
  }), (0, _defineProperty2["default"])(_$concat12, "> ".concat(componentCls, "-item:last-child"), {
    borderBottom: 0
  }), (0, _defineProperty2["default"])(_$concat12, "> ".concat(componentCls, "-item > ").concat(componentCls, "-content"), {
    backgroundColor: 'transparent',
    borderTop: 0
  }), (0, _defineProperty2["default"])(_$concat12, "> ".concat(componentCls, "-item > ").concat(componentCls, "-content > ").concat(componentCls, "-content-box"), {
    paddingTop: paddingXXS
  }), _$concat12));
};

var _default = (0, _theme.genComponentStyleHook)('Collapse', function (token) {
  var collapseToken = (0, _theme.mergeToken)(token, {
    collapseContentBg: token.colorBgContainer,
    collapseContentPadding: token.padding,
    collapseHeaderBg: token.colorBgContainerSecondary,
    collapseHeaderPadding: "".concat(token.paddingSM, "px ").concat(token.padding, "px"),
    collapsePanelBorderRadius: token.radiusBase
  });
  return [genBaseStyle(collapseToken), genBorderlessStyle(collapseToken), genArrowStyle(collapseToken)];
});

exports["default"] = _default;