"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useTheme;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _useMemo = _interopRequireDefault(require("rc-util/lib/hooks/useMemo"));

var _shallowequal = _interopRequireDefault(require("shallowequal"));

function useTheme(theme, parentTheme) {
  var themeConfig = theme || {};
  var parentThemeConfig = parentTheme || {};
  var mergedTheme = (0, _useMemo["default"])(function () {
    if (!theme) {
      return parentTheme;
    } // Override


    var mergedOverride = (0, _extends2["default"])({}, parentThemeConfig.override);
    Object.keys(theme.override || {}).forEach(function (componentName) {
      mergedOverride[componentName] = (0, _extends2["default"])((0, _extends2["default"])({}, mergedOverride[componentName]), theme.override[componentName]);
    }); // Base token

    var merged = (0, _extends2["default"])((0, _extends2["default"])((0, _extends2["default"])({}, parentThemeConfig), themeConfig), {
      token: (0, _extends2["default"])((0, _extends2["default"])({}, parentThemeConfig.token), themeConfig.token),
      override: mergedOverride
    });
    return merged;
  }, [themeConfig, parentThemeConfig], function (prev, next) {
    return prev.some(function (prevTheme, index) {
      var nextTheme = next[index];
      return !(0, _shallowequal["default"])(prevTheme, nextTheme);
    });
  });
  return mergedTheme;
}