"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _motion = require("../../style/motion");

var _theme = require("../../theme");

var _button = _interopRequireDefault(require("./button"));

var _status = _interopRequireDefault(require("./status"));

// deps-lint-skip-all
// =============================== Base ===============================
var genBaseStyle = function genBaseStyle(token) {
  var _$concat, _extends2, _$concat$concat, _menuCls, _ref2;

  var componentCls = token.componentCls,
      menuCls = token.menuCls,
      zIndexPopup = token.zIndexPopup,
      dropdownArrowDistance = token.dropdownArrowDistance,
      dropdownArrowOffset = token.dropdownArrowOffset,
      sizePopupArrow = token.sizePopupArrow,
      antCls = token.antCls,
      iconCls = token.iconCls,
      motionDurationMid = token.motionDurationMid,
      motionDurationSlow = token.motionDurationSlow,
      dropdownPaddingVertical = token.dropdownPaddingVertical,
      fontSizeBase = token.fontSizeBase,
      dropdownEdgeChildVerticalPadding = token.dropdownEdgeChildVerticalPadding,
      radiusBase = token.radiusBase,
      colorTextDisabled = token.colorTextDisabled,
      fontSizeIcon = token.fontSizeIcon,
      controlPaddingHorizontal = token.controlPaddingHorizontal,
      colorBgElevated = token.colorBgElevated;
  return [(0, _defineProperty2["default"])({}, componentCls, (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    position: 'absolute',
    top: -9999,
    left: {
      _skip_check_: true,
      value: -9999
    },
    zIndex: zIndexPopup,
    display: 'block',
    // A placeholder out of dropdown visible range to avoid close when user moving
    '&::before': {
      position: 'absolute',
      insetBlock: -dropdownArrowDistance + sizePopupArrow,
      // insetInlineStart: -7, // FIXME: Seems not work for hidden element
      zIndex: -9999,
      opacity: 0.0001,
      content: '""'
    }
  }, (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-wrap"), (_$concat = {
    position: 'relative'
  }, (0, _defineProperty2["default"])(_$concat, "".concat(antCls, "-btn > ").concat(iconCls, "-down"), {
    fontSize: fontSizeIcon
  }), (0, _defineProperty2["default"])(_$concat, "".concat(iconCls, "-down::before"), {
    transition: "transform ".concat(motionDurationMid)
  }), _$concat)), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-wrap-open"), (0, _defineProperty2["default"])({}, "".concat(iconCls, "-down::before"), {
    transform: "rotate(180deg)"
  })), (0, _defineProperty2["default"])(_extends2, "\n        &-hidden,\n        &-menu-hidden,\n        &-menu-submenu-hidden\n      ", {
    display: 'none'
  }), (0, _defineProperty2["default"])(_extends2, "\n        &-show-arrow&-placement-topLeft,\n        &-show-arrow&-placement-top,\n        &-show-arrow&-placement-topRight\n      ", {
    paddingBottom: dropdownArrowDistance
  }), (0, _defineProperty2["default"])(_extends2, "\n        &-show-arrow&-placement-bottomLeft,\n        &-show-arrow&-placement-bottom,\n        &-show-arrow&-placement-bottomRight\n      ", {
    paddingTop: dropdownArrowDistance
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-arrow"), (0, _extends3["default"])({
    position: 'absolute',
    zIndex: 1,
    display: 'block',
    width: sizePopupArrow,
    height: sizePopupArrow,
    // Use linear-gradient to prevent arrow from covering text
    background: "linear-gradient(135deg, transparent 40%, ".concat(colorBgElevated, " 40%)")
  }, (0, _theme.roundedArrow)(sizePopupArrow, 5, colorBgElevated))), (0, _defineProperty2["default"])(_extends2, "\n        &-placement-top > ".concat(componentCls, "-arrow,\n        &-placement-topLeft > ").concat(componentCls, "-arrow,\n        &-placement-topRight > ").concat(componentCls, "-arrow\n      "), {
    bottom: sizePopupArrow * Math.sqrt(1 / 2) + 2,
    boxShadow: token.boxShadowPopoverArrow,
    transform: 'rotate(45deg)'
  }), (0, _defineProperty2["default"])(_extends2, "&-placement-top > ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: '50%'
    },
    transform: 'translateX(-50%) rotate(45deg)'
  }), (0, _defineProperty2["default"])(_extends2, "&-placement-topLeft > ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_extends2, "&-placement-topRight > ".concat(componentCls, "-arrow"), {
    right: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_extends2, "\n          &-placement-bottom > ".concat(componentCls, "-arrow,\n          &-placement-bottomLeft > ").concat(componentCls, "-arrow,\n          &-placement-bottomRight > ").concat(componentCls, "-arrow\n        "), {
    top: (sizePopupArrow + 2) * Math.sqrt(1 / 2),
    boxShadow: token.boxShadowPopoverArrowBottom,
    transform: "rotate(-135deg) translateY(-0.5px)" // FIXME: hardcode

  }), (0, _defineProperty2["default"])(_extends2, "&-placement-bottom > ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: '50%'
    },
    transform: "translateX(-50%) rotate(-135deg) translateY(-0.5px)"
  }), (0, _defineProperty2["default"])(_extends2, "&-placement-bottomLeft > ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_extends2, "&-placement-bottomRight > ".concat(componentCls, "-arrow"), {
    right: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(antCls, "-slide-down-enter").concat(antCls, "-slide-down-enter-active&-placement-bottomLeft,\n          &").concat(antCls, "-slide-down-appear").concat(antCls, "-slide-down-appear-active&-placement-bottomLeft\n          &").concat(antCls, "-slide-down-enter").concat(antCls, "-slide-down-enter-active&-placement-bottom,\n          &").concat(antCls, "-slide-down-appear").concat(antCls, "-slide-down-appear-active&-placement-bottom,\n          &").concat(antCls, "-slide-down-enter").concat(antCls, "-slide-down-enter-active&-placement-bottomRight,\n          &").concat(antCls, "-slide-down-appear").concat(antCls, "-slide-down-appear-active&-placement-bottomRight"), {
    animationName: _motion.slideUpIn
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(antCls, "-slide-up-enter").concat(antCls, "-slide-up-enter-active&-placement-topLeft,\n          &").concat(antCls, "-slide-up-appear").concat(antCls, "-slide-up-appear-active&-placement-topLeft,\n          &").concat(antCls, "-slide-up-enter").concat(antCls, "-slide-up-enter-active&-placement-top,\n          &").concat(antCls, "-slide-up-appear").concat(antCls, "-slide-up-appear-active&-placement-top,\n          &").concat(antCls, "-slide-up-enter").concat(antCls, "-slide-up-enter-active&-placement-topRight,\n          &").concat(antCls, "-slide-up-appear").concat(antCls, "-slide-up-appear-active&-placement-topRight"), {
    animationName: _motion.slideDownIn
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(antCls, "-slide-down-leave").concat(antCls, "-slide-down-leave-active&-placement-bottomLeft,\n          &").concat(antCls, "-slide-down-leave").concat(antCls, "-slide-down-leave-active&-placement-bottom,\n          &").concat(antCls, "-slide-down-leave").concat(antCls, "-slide-down-leave-active&-placement-bottomRight"), {
    animationName: _motion.slideUpOut
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(antCls, "-slide-up-leave").concat(antCls, "-slide-up-leave-active&-placement-topLeft,\n          &").concat(antCls, "-slide-up-leave").concat(antCls, "-slide-up-leave-active&-placement-top,\n          &").concat(antCls, "-slide-up-leave").concat(antCls, "-slide-up-leave-active&-placement-topRight"), {
    animationName: _motion.slideDownOut
  }), _extends2))), (_ref2 = {}, (0, _defineProperty2["default"])(_ref2, "".concat(componentCls, " ").concat(menuCls), {
    position: 'relative',
    margin: 0
  }), (0, _defineProperty2["default"])(_ref2, "".concat(menuCls, "-submenu-popup"), {
    position: 'absolute',
    zIndex: zIndexPopup,
    background: 'transparent',
    boxShadow: 'none',
    transformOrigin: '0 0',
    'ul,li': {
      listStyle: 'none'
    },
    ul: {
      marginInline: '0.3em'
    }
  }), (0, _defineProperty2["default"])(_ref2, "".concat(componentCls, ", ").concat(componentCls, "-menu-submenu"), (0, _defineProperty2["default"])({}, menuCls, (_menuCls = {
    padding: "".concat(dropdownEdgeChildVerticalPadding, "px 0"),
    listStyleType: 'none',
    backgroundColor: colorBgElevated,
    backgroundClip: 'padding-box',
    borderRadius: token.controlRadius,
    outline: 'none',
    boxShadow: token.boxShadow
  }, (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-item-group-title"), {
    padding: "".concat(dropdownPaddingVertical, "px ").concat(controlPaddingHorizontal, "px"),
    color: token.colorTextSecondary,
    transition: "all ".concat(motionDurationSlow)
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-item"), {
    position: 'relative',
    display: 'flex',
    alignItems: 'center'
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-item-icon"), {
    minWidth: fontSizeBase,
    marginInlineEnd: token.marginXS,
    fontSize: token.fontSizeSM
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-title-content"), {
    flex: 'auto',
    '> a': {
      color: 'inherit',
      transition: "all ".concat(motionDurationSlow),
      '&:hover': {
        color: 'inherit'
      },
      '&::after': {
        position: 'absolute',
        inset: 0,
        content: '""'
      }
    }
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-item, ").concat(menuCls, "-submenu-title"), (_$concat$concat = {
    clear: 'both',
    margin: 0,
    padding: "".concat(dropdownPaddingVertical, "px ").concat(controlPaddingHorizontal, "px"),
    color: token.colorText,
    fontWeight: 'normal',
    fontSize: fontSizeBase,
    lineHeight: token.lineHeight,
    cursor: 'pointer',
    transition: "all ".concat(motionDurationSlow),
    '&:first-child': !dropdownEdgeChildVerticalPadding ? {
      borderRadius: "".concat(radiusBase, "px ").concat(radiusBase, "px 0 0")
    } : [],
    '&:last-child': !dropdownEdgeChildVerticalPadding ? {
      borderRadius: "0 0 ".concat(radiusBase, "px ").concat(radiusBase, "px")
    } : [],
    '&-selected': {
      color: token.colorPrimary,
      backgroundColor: token.controlItemBgActive
    }
  }, (0, _defineProperty2["default"])(_$concat$concat, "&:hover, &-active", {
    backgroundColor: token.controlItemBgHover
  }), (0, _defineProperty2["default"])(_$concat$concat, '&-disabled', {
    color: colorTextDisabled,
    cursor: 'not-allowed',
    '&:hover': {
      color: colorTextDisabled,
      backgroundColor: colorBgElevated,
      cursor: 'not-allowed'
    },
    a: {
      pointerEvents: 'none'
    }
  }), (0, _defineProperty2["default"])(_$concat$concat, '&-divider', {
    height: 1,
    margin: "".concat(token.marginXXS, "px 0"),
    overflow: 'hidden',
    lineHeight: 0,
    backgroundColor: token.colorSplit
  }), (0, _defineProperty2["default"])(_$concat$concat, "".concat(componentCls, "-menu-submenu-expand-icon"), (0, _defineProperty2["default"])({
    position: 'absolute',
    insetInlineEnd: token.paddingXS
  }, "".concat(componentCls, "-menu-submenu-arrow-icon"), {
    marginInlineEnd: '0 !important',
    color: token.colorTextSecondary,
    fontSize: fontSizeIcon,
    fontStyle: 'normal'
  })), _$concat$concat)), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-item-group-list"), {
    margin: "0 ".concat(token.marginXS, "px"),
    padding: 0,
    listStyle: 'none'
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-submenu-title"), {
    paddingInlineEnd: controlPaddingHorizontal + token.fontSizeSM
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-submenu-vertical"), {
    position: 'relative'
  }), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-submenu").concat(menuCls, "-submenu-disabled ").concat(componentCls, "-menu-submenu-title"), (0, _defineProperty2["default"])({}, "&, ".concat(componentCls, "-menu-submenu-arrow-icon"), {
    color: colorTextDisabled,
    backgroundColor: colorBgElevated,
    cursor: 'not-allowed'
  })), (0, _defineProperty2["default"])(_menuCls, "".concat(menuCls, "-submenu-selected ").concat(componentCls, "-menu-submenu-title"), {
    color: token.colorPrimary
  }), _menuCls))), _ref2), // Follow code may reuse in other components
  [(0, _motion.initSlideMotion)(token, 'slide-up'), (0, _motion.initSlideMotion)(token, 'slide-down'), (0, _motion.initMoveMotion)(token, 'move-up'), (0, _motion.initMoveMotion)(token, 'move-down')]];
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Dropdown', function (token, _ref3) {
  var rootPrefixCls = _ref3.rootPrefixCls;
  var marginXXS = token.marginXXS,
      sizePopupArrow = token.sizePopupArrow,
      controlHeight = token.controlHeight,
      fontSizeBase = token.fontSizeBase,
      lineHeight = token.lineHeight,
      paddingXXS = token.paddingXXS,
      componentCls = token.componentCls;
  var dropdownPaddingVertical = (controlHeight - fontSizeBase * lineHeight) / 2;
  var dropdownToken = (0, _theme.mergeToken)(token, {
    menuCls: "".concat(componentCls, "-menu"),
    rootPrefixCls: rootPrefixCls,
    dropdownArrowDistance: sizePopupArrow + marginXXS,
    dropdownArrowOffset: sizePopupArrow / Math.sqrt(2) * 2,
    dropdownPaddingVertical: dropdownPaddingVertical,
    dropdownEdgeChildVerticalPadding: paddingXXS
  });
  return [genBaseStyle(dropdownToken), (0, _button["default"])(dropdownToken), (0, _status["default"])(dropdownToken)];
}, function (token) {
  return {
    zIndexPopup: token.zIndexPopupBase + 50
  };
});

exports["default"] = _default;