"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends5 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _style = require("../../input/style/css");

var _theme = require("../../theme");

var genInputNumberStyles = function genInputNumberStyles(token) {
  var _componentCls;

  var componentCls = token.componentCls,
      controlLineWidth = token.controlLineWidth,
      controlLineType = token.controlLineType,
      colorBorder = token.colorBorder,
      controlRadius = token.controlRadius,
      fontSizeLG = token.fontSizeLG,
      controlHeightLG = token.controlHeightLG,
      controlHeightSM = token.controlHeightSM,
      colorError = token.colorError,
      inputPaddingHorizontalSM = token.inputPaddingHorizontalSM,
      colorTextSecondary = token.colorTextSecondary,
      motionDurationFast = token.motionDurationFast,
      colorPrimary = token.colorPrimary,
      controlHeight = token.controlHeight,
      inputPaddingHorizontal = token.inputPaddingHorizontal,
      motionDurationSlow = token.motionDurationSlow,
      colorBgContainer = token.colorBgContainer,
      motionDurationMid = token.motionDurationMid,
      colorTextDisabled = token.colorTextDisabled,
      controlWidth = token.controlWidth;
  return [(0, _defineProperty2["default"])({}, componentCls, (0, _extends5["default"])((0, _extends5["default"])((0, _extends5["default"])((0, _extends5["default"])({}, (0, _theme.resetComponent)(token)), (0, _style.genBasicInputStyle)(token)), (0, _style.genStatusStyle)(token)), (0, _defineProperty2["default"])({
    display: 'inline-block',
    width: controlWidth,
    margin: 0,
    padding: 0,
    border: "".concat(controlLineWidth, "px ").concat(controlLineType, " ").concat(colorBorder),
    borderRadius: controlRadius,
    '&-rtl': (0, _defineProperty2["default"])({
      direction: 'rtl'
    }, "".concat(componentCls, "-input"), {
      direction: 'rtl'
    }),
    '&-lg': (0, _defineProperty2["default"])({
      padding: 0,
      fontSize: fontSizeLG
    }, "input".concat(componentCls, "-input"), {
      height: controlHeightLG - 2 * controlLineWidth
    }),
    '&-sm': (0, _defineProperty2["default"])({
      padding: 0
    }, "input".concat(componentCls, "-input"), {
      height: controlHeightSM - 2 * controlLineWidth,
      padding: "0 ".concat(inputPaddingHorizontalSM, "px")
    }),
    '&:hover': (0, _extends5["default"])({}, (0, _style.genHoverStyle)(token)),
    '&-focused': (0, _extends5["default"])({}, (0, _style.genActiveStyle)(token)),
    '&-disabled': (0, _extends5["default"])((0, _extends5["default"])({}, (0, _style.genDisabledStyle)(token)), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-input"), {
      cursor: 'not-allowed'
    })),
    // ===================== Out Of Range =====================
    '&-out-of-range': {
      input: {
        color: colorError
      }
    },
    // Style for input-group: input with label, with button or dropdown...
    '&-group': (0, _extends5["default"])((0, _extends5["default"])((0, _extends5["default"])({}, (0, _theme.resetComponent)(token)), (0, _style.genInputGroupStyle)(token)), {
      '&-wrapper': (0, _defineProperty2["default"])({
        display: 'inline-block',
        textAlign: 'start',
        verticalAlign: 'top'
      }, "".concat(componentCls, "-affix-wrapper"), {
        width: '100%'
      })
    })
  }, componentCls, {
    '&-input': (0, _extends5["default"])((0, _extends5["default"])({
      width: '100%',
      height: controlHeight - 2 * controlLineWidth,
      padding: "0 ".concat(inputPaddingHorizontal, "px"),
      textAlign: 'start',
      backgroundColor: 'transparent',
      border: 0,
      borderRadius: controlRadius,
      outline: 0,
      transition: "all ".concat(motionDurationSlow, " linear"),
      appearance: 'textfield'
    }, (0, _style.genPlaceholderStyle)(token.colorTextPlaceholder)), {
      '&[type="number"]::-webkit-inner-spin-button, &[type="number"]::-webkit-outer-spin-button': {
        margin: 0,

        /* stylelint-disable-next-line property-no-vendor-prefix */
        webkitAppearance: 'none',
        appearance: 'none'
      }
    })
  }))), // Handler
  (0, _defineProperty2["default"])({}, componentCls, (_componentCls = {}, (0, _defineProperty2["default"])(_componentCls, "&:hover ".concat(componentCls, "-handler-wrap, &-focused ").concat(componentCls, "-handler-wrap"), {
    opacity: 1
  }), (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-handler-wrap"), (0, _defineProperty2["default"])({
    position: 'absolute',
    insetBlockStart: 0,
    insetInlineEnd: 0,
    width: token.handleWidth,
    height: '100%',
    background: colorBgContainer,
    borderStartStartRadius: 0,
    borderStartEndRadius: controlRadius,
    borderEndEndRadius: controlRadius,
    borderEndStartRadius: 0,
    opacity: 0,
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'stretch',
    transition: "opacity ".concat(motionDurationMid, " linear ").concat(motionDurationFast)
  }, "".concat(componentCls, "-handler"), (0, _defineProperty2["default"])({
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    flex: 'auto',
    height: '40%'
  }, "\n              ".concat(componentCls, "-handler-up-inner,\n              ").concat(componentCls, "-handler-down-inner\n            "), {
    marginInlineEnd: 0,
    fontSize: token.handleFontSize
  }))), (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-handler"), {
    height: '50%',
    overflow: 'hidden',
    color: colorTextSecondary,
    fontWeight: 'bold',
    lineHeight: 0,
    textAlign: 'center',
    cursor: 'pointer',
    borderInlineStart: "".concat(controlLineWidth, "px ").concat(controlLineType, " ").concat(colorBorder),
    transition: "all ".concat(motionDurationFast, " linear"),
    '&:active': {
      background: token.colorBgContainerSecondary
    },
    // Hover
    '&:hover': (0, _defineProperty2["default"])({
      height: "60%"
    }, "\n              ".concat(componentCls, "-handler-up-inner,\n              ").concat(componentCls, "-handler-down-inner\n            "), {
      color: colorPrimary
    }),
    '&-up-inner, &-down-inner': (0, _extends5["default"])((0, _extends5["default"])({}, (0, _theme.resetIcon)()), {
      color: colorTextSecondary,
      transition: "all ".concat(motionDurationFast, " linear"),
      userSelect: 'none'
    })
  }), (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-handler-up"), {
    borderStartEndRadius: controlRadius
  }), (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-handler-down"), {
    borderBlockStart: "".concat(controlLineWidth, "px ").concat(controlLineType, " ").concat(colorBorder),
    borderEndEndRadius: controlRadius
  }), (0, _defineProperty2["default"])(_componentCls, '&-disabled, &-readonly', (0, _defineProperty2["default"])({}, "".concat(componentCls, "-handler-wrap"), {
    display: 'none'
  })), (0, _defineProperty2["default"])(_componentCls, "\n          ".concat(componentCls, "-handler-up-disabled,\n          ").concat(componentCls, "-handler-down-disabled\n        "), {
    cursor: 'not-allowed'
  }), (0, _defineProperty2["default"])(_componentCls, "\n          ".concat(componentCls, "-handler-up-disabled:hover &-handler-up-inner,\n          ").concat(componentCls, "-handler-down-disabled:hover &-handler-down-inner\n        "), {
    color: colorTextDisabled
  }), _componentCls)), // Border-less
  (0, _defineProperty2["default"])({}, "".concat(componentCls, "-borderless"), (0, _defineProperty2["default"])({
    borderColor: 'transparent',
    boxShadow: 'none'
  }, "".concat(componentCls, "-handler-down"), {
    borderBlockStartWidth: 0
  }))];
};

var genAffixWrapperStyles = function genAffixWrapperStyles(token) {
  var _extends4;

  var componentCls = token.componentCls,
      inputPaddingHorizontal = token.inputPaddingHorizontal,
      inputAffixPadding = token.inputAffixPadding,
      controlWidth = token.controlWidth;
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-affix-wrapper"), (0, _extends5["default"])((0, _extends5["default"])((0, _extends5["default"])({}, (0, _style.genBasicInputStyle)(token)), (0, _style.genStatusStyle)(token)), (_extends4 = {
    // or number handler will cover form status
    position: 'relative',
    display: 'inline-flex',
    width: controlWidth,
    padding: 0,
    paddingInlineStart: inputPaddingHorizontal,
    '&:not(&-disabled):hover': (0, _extends5["default"])((0, _extends5["default"])({}, (0, _style.genHoverStyle)(token)), {
      zIndex: 1
    }),
    '&-focused, &:focus': {
      zIndex: 1
    },
    '&-disabled': (0, _defineProperty2["default"])({}, "".concat(componentCls, "[disabled]"), {
      background: 'transparent'
    })
  }, (0, _defineProperty2["default"])(_extends4, "> div".concat(componentCls), (0, _defineProperty2["default"])({
    width: '100%',
    border: 'none',
    outline: 'none'
  }, "&".concat(componentCls, "-focused"), {
    boxShadow: 'none !important'
  })), (0, _defineProperty2["default"])(_extends4, "input".concat(componentCls, "-input"), {
    padding: 0
  }), (0, _defineProperty2["default"])(_extends4, '&::before', {
    width: 0,
    visibility: 'hidden',
    content: '"\\a0"'
  }), (0, _defineProperty2["default"])(_extends4, "".concat(componentCls, "-handler-wrap"), {
    zIndex: 2
  }), (0, _defineProperty2["default"])(_extends4, componentCls, {
    '&-prefix, &-suffix': {
      display: 'flex',
      flex: 'none',
      alignItems: 'center',
      pointerEvents: 'none'
    },
    '&-prefix': {
      marginInlineEnd: inputAffixPadding
    },
    '&-suffix': {
      position: 'absolute',
      insetBlockStart: 0,
      insetInlineEnd: 0,
      zIndex: 1,
      height: '100%',
      marginInlineEnd: inputPaddingHorizontal,
      marginInlineStart: inputAffixPadding
    }
  }), _extends4)));
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('InputNumber', function (token) {
  var inputNumberToken = (0, _style.initInputToken)(token);
  return [genInputNumberStyles(inputNumberToken), genAffixWrapperStyles(inputNumberToken)];
}, function (token) {
  return {
    controlWidth: 90,
    handleWidth: token.controlHeightSM - token.controlLineWidth * 2,
    handleFontSize: token.fontSize / 2
  };
});

exports["default"] = _default;