"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends4 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _tinycolor = require("@ctrl/tinycolor");

var _theme = require("../../theme");

var _horizontal = _interopRequireDefault(require("./horizontal"));

var _rtl = _interopRequireDefault(require("./rtl"));

var _theme2 = _interopRequireDefault(require("./theme"));

var _vertical = _interopRequireDefault(require("./vertical"));

// deps-lint-skip-all
// =============================== Base ===============================
var getBaseStyle = function getBaseStyle(token) {
  var _$concat$concat, _$concat5, _extends3;

  var antCls = token.antCls,
      componentCls = token.componentCls,
      fontSize = token.fontSize,
      motionDurationSlow = token.motionDurationSlow,
      motionDurationMid = token.motionDurationMid,
      motionEaseInOut = token.motionEaseInOut,
      motionEaseOut = token.motionEaseOut,
      lineHeight = token.lineHeight,
      paddingXS = token.paddingXS,
      padding = token.padding,
      colorBorderSecondary = token.colorBorderSecondary,
      lineWidth = token.lineWidth,
      iconCls = token.iconCls,
      zIndexPopup = token.zIndexPopup,
      radiusBase = token.radiusBase,
      menuArrowSize = token.menuArrowSize,
      controlHeightSM = token.controlHeightSM,
      menuArrowOffset = token.menuArrowOffset,
      lineType = token.lineType,
      menuPanelMaskInset = token.menuPanelMaskInset;
  return [// Misc
  (0, _defineProperty2["default"])({
    '': (0, _defineProperty2["default"])({}, "".concat(componentCls), (0, _extends4["default"])((0, _extends4["default"])({}, (0, _theme.clearFix)()), (0, _defineProperty2["default"])({}, "&-hidden", {
      display: 'none'
    })))
  }, "".concat(componentCls, "-submenu-hidden"), {
    display: 'none'
  }), (0, _defineProperty2["default"])({}, componentCls, (0, _extends4["default"])((0, _extends4["default"])({}, (0, _theme.resetComponent)(token)), (_extends3 = {
    marginBottom: 0,
    paddingInlineStart: 0,
    // Override default ul/ol
    fontSize: fontSize,
    lineHeight: 0,
    listStyle: 'none',
    outline: 'none',
    transition: ["background ".concat(motionDurationSlow), // Magic cubic here but smooth transition
    "width ".concat(motionDurationSlow, " cubic-bezier(0.2, 0, 0, 1) 0s")].join(',')
  }, (0, _defineProperty2["default"])(_extends3, "ul, ol", {
    margin: 0,
    padding: 0,
    listStyle: 'none'
  }), (0, _defineProperty2["default"])(_extends3, "&-overflow", (0, _defineProperty2["default"])({
    display: 'flex'
  }, "".concat(componentCls, "-item"), {
    flex: 'none'
  })), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-item-group-title"), {
    padding: "".concat(paddingXS, "px ").concat(padding, "px"),
    fontSize: fontSize,
    lineHeight: lineHeight,
    transition: "all ".concat(motionDurationSlow)
  }), (0, _defineProperty2["default"])(_extends3, "&-horizontal ".concat(componentCls, "-submenu"), {
    transition: ["border-color ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "background ".concat(motionDurationSlow, " ").concat(motionEaseInOut)].join(',')
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-submenu, ").concat(componentCls, "-submenu-inline"), {
    transition: ["border-color ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "background ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "padding ".concat(motionDurationMid, " ").concat(motionEaseInOut)].join(',')
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-submenu ").concat(componentCls, "-sub"), {
    cursor: 'initial',
    transition: ["background ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "padding ".concat(motionDurationSlow, " ").concat(motionEaseInOut)]
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-title-content"), {
    transition: "color ".concat(motionDurationSlow)
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-item a"), {
    '&::before': {
      position: 'absolute',
      inset: 0,
      backgroundColor: 'transparent',
      content: '""'
    }
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-item-divider"), {
    overflow: 'hidden',
    lineHeight: 0,
    borderColor: colorBorderSecondary,
    borderStyle: lineType,
    borderTopWidth: lineWidth,
    marginBlock: lineWidth,
    padding: 0,
    '&-dashed': {
      borderStyle: 'dashed'
    }
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-item, ").concat(componentCls, "-submenu-title"), (_$concat$concat = {
    position: 'relative',
    display: 'block',
    margin: 0,
    // paddingInline: menuItemPaddingInline,
    whiteSpace: 'nowrap',
    cursor: 'pointer',
    transition: ["border-color ".concat(motionDurationSlow), "background ".concat(motionDurationSlow), "padding ".concat(motionDurationSlow, " ").concat(motionEaseInOut)].join(',')
  }, (0, _defineProperty2["default"])(_$concat$concat, "".concat(componentCls, "-item-icon, ").concat(iconCls), {
    minWidth: fontSize,
    fontSize: fontSize,
    transition: ["font-size ".concat(motionDurationMid, " ").concat(motionEaseOut), "margin ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "color ".concat(motionDurationSlow)].join(','),
    '+ span': {
      marginInlineStart: controlHeightSM - fontSize,
      opacity: 1,
      transition: ["opacity ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "margin ".concat(motionDurationSlow), "color ".concat(motionDurationSlow)].join(',')
    }
  }), (0, _defineProperty2["default"])(_$concat$concat, "".concat(componentCls, "-item-icon"), (0, _extends4["default"])({}, (0, _theme.resetIcon)())), (0, _defineProperty2["default"])(_$concat$concat, "&.".concat(componentCls, "-item-only-child"), (0, _defineProperty2["default"])({}, "> ".concat(iconCls, ", > ").concat(componentCls, "-item-icon"), {
    marginInlineEnd: 0
  })), _$concat$concat)), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-item-disabled, ").concat(componentCls, "-submenu-disabled"), (0, _defineProperty2["default"])({
    background: 'none !important',
    cursor: 'not-allowed',
    '&::after': {
      borderColor: 'transparent !important'
    },
    a: {
      color: 'inherit !important',
      pointerEvents: 'none'
    }
  }, "> ".concat(componentCls, "-submenu-title"), {
    color: 'inherit !important',
    cursor: 'not-allowed'
  })), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-item-group"), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-item-group-list"), (0, _defineProperty2["default"])({
    margin: 0,
    padding: 0
  }, "".concat(componentCls, "-item, ").concat(componentCls, "-submenu-title"), {
    paddingInline: "".concat(fontSize * 2, "px ").concat(padding, "px")
  }))), (0, _defineProperty2["default"])(_extends3, '&-submenu', (0, _defineProperty2["default"])({
    '&-popup': {
      position: 'absolute',
      zIndex: zIndexPopup,
      background: 'transparent',
      borderRadius: radiusBase,
      boxShadow: 'none',
      transformOrigin: '0 0',
      // https://github.com/ant-design/ant-design/issues/13955
      '&::before': {
        position: 'absolute',
        inset: "".concat(menuPanelMaskInset, "px 0 0"),
        zIndex: -1,
        width: '100%',
        height: '100%',
        opacity: 0,
        content: '""'
      }
    },
    // https://github.com/ant-design/ant-design/issues/13955
    '&-placement-rightTop::before': {
      top: 0,
      insetInlineStart: menuPanelMaskInset
    }
  }, "> ".concat(componentCls), (0, _defineProperty2["default"])({
    borderRadius: radiusBase
  }, "".concat(componentCls, "-submenu-title::after"), {
    transition: "transform ".concat(motionDurationSlow, " ").concat(motionEaseInOut)
  }))), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-submenu"), (_$concat5 = {}, (0, _defineProperty2["default"])(_$concat5, "&-expand-icon, &-arrow", {
    position: 'absolute',
    top: '50%',
    insetInlineEnd: token.margin,
    width: menuArrowSize,
    color: 'currentcolor',
    transform: 'translateY(-50%)',
    transition: "transform ".concat(motionDurationSlow, " ").concat(motionEaseInOut)
  }), (0, _defineProperty2["default"])(_$concat5, '&-arrow', {
    // →
    '&::before, &::after': {
      position: 'absolute',
      width: menuArrowSize * 0.6,
      height: menuArrowSize * 0.15,
      backgroundColor: 'currentcolor',
      borderRadius: radiusBase,
      transition: ["background ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "transform ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "top ".concat(motionDurationSlow, " ").concat(motionEaseInOut), "color ".concat(motionDurationSlow, " ").concat(motionEaseInOut)].join(','),
      content: '""'
    },
    '&::before': {
      transform: "rotate(45deg) translateY(-".concat(menuArrowOffset, ")")
    },
    '&::after': {
      transform: "rotate(-45deg) translateY(".concat(menuArrowOffset, ")")
    }
  }), _$concat5)), (0, _defineProperty2["default"])(_extends3, "&-inline-collapsed ".concat(componentCls, "-submenu-arrow,\n        &-inline ").concat(componentCls, "-submenu-arrow"), {
    // ↓
    '&::before': {
      transform: "rotate(-45deg) translateX(".concat(menuArrowOffset, ")")
    },
    '&::after': {
      transform: "rotate(45deg) translateX(-".concat(menuArrowOffset, ")")
    }
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-submenu-open").concat(componentCls, "-submenu-inline > ").concat(componentCls, "-submenu-title > ").concat(componentCls, "-submenu-arrow"), {
    // ↑
    transform: "translateY(-".concat(menuArrowSize * 0.2, "px)"),
    '&::after': {
      transform: "rotate(-45deg) translateX(-".concat(menuArrowOffset, ")")
    },
    '&::before': {
      transform: "rotate(45deg) translateX(".concat(menuArrowOffset, ")")
    }
  }), _extends3))), // Integration with header element so menu items have the same height
  (0, _defineProperty2["default"])({}, "".concat(antCls, "-layout-header"), (0, _defineProperty2["default"])({}, componentCls, {
    lineHeight: 'inherit'
  }))];
}; // ============================== Export ==============================


var _default = function _default(prefixCls, injectStyle) {
  var useOriginHook = (0, _theme.genComponentStyleHook)('Menu', function (token) {
    // Dropdown will handle menu style self. We do not need to handle this.
    if (injectStyle === false) {
      return [];
    }

    var colorPrimary = token.colorPrimary,
        colorError = token.colorError,
        colorTextDisabled = token.colorTextDisabled,
        colorErrorHover = token.colorErrorHover,
        colorErrorOutline = token.colorErrorOutline,
        colorText = token.colorText,
        colorTextLightSolid = token.colorTextLightSolid,
        colorTextSecondary = token.colorTextSecondary,
        colorBgContainer = token.colorBgContainer,
        colorBgContainerSecondary = token.colorBgContainerSecondary,
        controlHeightLG = token.controlHeightLG,
        fontSize = token.fontSize,
        controlItemBgActive = token.controlItemBgActive,
        lineWidth = token.lineWidth,
        lineWidthBold = token.lineWidthBold;
    var menuArrowSize = fontSize / 7 * 5; // Menu Token

    var menuToken = (0, _theme.mergeToken)(token, {
      menuItemHeight: controlHeightLG,
      menuItemPaddingInline: controlHeightLG / 2,
      menuArrowSize: menuArrowSize,
      menuHorizontalHeight: controlHeightLG * 1.15,
      menuArrowOffset: "".concat(menuArrowSize * 0.25, "px"),
      menuPanelMaskInset: -7 // Still a hardcode here since it's offset by rc-align

    }); // Theme Token

    var menuLightToken = (0, _theme.mergeToken)(menuToken, {
      themeColorText: colorText,
      themeColorTextHover: colorPrimary,
      themeColorTextSecondary: colorTextSecondary,
      themeColorTextSelect: colorPrimary,
      themeColorBg: colorBgContainer,
      themeColorBgSecondary: colorBgContainerSecondary,
      themeColorBgActive: controlItemBgActive,
      themeColorBgSelect: controlItemBgActive,
      themeInkBarWidth: lineWidthBold + lineWidth,
      themeInkBarHeight: lineWidthBold,
      themeInkBorderSize: lineWidth,
      // Disabled
      themeColorDisabledText: colorTextDisabled,
      // Danger
      themeColorDangerText: colorError,
      themeColorDangerTextHover: colorError,
      themeColorDangerTextSelect: colorError,
      themeColorDangerBgActive: colorErrorOutline,
      themeColorDangerBgSelect: colorErrorOutline
    });
    var menuDarkToken = (0, _theme.mergeToken)(menuToken, {
      themeColorText: new _tinycolor.TinyColor(colorTextLightSolid).setAlpha(0.65).toRgbString(),
      themeColorTextHover: colorTextLightSolid,
      themeColorTextSecondary: colorTextSecondary,
      themeColorTextSelect: colorTextLightSolid,
      themeColorBg: '#001529',
      themeColorBgSecondary: '#000c17',
      themeColorBgActive: 'transparent',
      themeColorBgSelect: colorPrimary,
      themeInkBarWidth: 0,
      themeInkBarHeight: 0,
      themeInkBorderSize: 0,
      // Disabled
      themeColorDisabledText: new _tinycolor.TinyColor(colorTextLightSolid).setAlpha(0.25).toRgbString(),
      // Danger
      themeColorDangerText: colorError,
      themeColorDangerTextHover: colorErrorHover,
      themeColorDangerTextSelect: colorTextLightSolid,
      themeColorDangerBgActive: colorError,
      themeColorDangerBgSelect: colorError
    });
    return [// Basic
    getBaseStyle(menuToken), // Horizontal
    (0, _horizontal["default"])(menuLightToken), // Vertical
    (0, _vertical["default"])(menuLightToken), // Theme
    (0, _theme2["default"])(menuLightToken, 'light'), (0, _theme2["default"])(menuDarkToken, 'dark'), // RTL
    (0, _rtl["default"])(menuToken)];
  }, function (token) {
    return {
      dropdownWidth: 160,
      zIndexPopup: token.zIndexPopupBase + 50
    };
  });
  return useOriginHook(prefixCls);
};

exports["default"] = _default;