"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var accessibilityFocus = function accessibilityFocus(token) {
  var controlOutlineWidth = token.controlOutlineWidth,
      colorPrimaryHover = token.colorPrimaryHover;
  return {
    boxShadow: "0 0 0 ".concat(controlOutlineWidth, "px ").concat(colorPrimaryHover)
  };
};

var getThemeStyle = function getThemeStyle(token, themeSuffix) {
  var _$concat3, _$concat4, _$concat8, _$concat$concat3;

  var componentCls = token.componentCls,
      themeColorText = token.themeColorText,
      themeColorTextSelect = token.themeColorTextSelect,
      themeColorTextSecondary = token.themeColorTextSecondary,
      themeColorBg = token.themeColorBg,
      themeColorBgSecondary = token.themeColorBgSecondary,
      themeColorBgActive = token.themeColorBgActive,
      themeColorBgSelect = token.themeColorBgSelect,
      themeInkBarHeight = token.themeInkBarHeight,
      themeInkBarWidth = token.themeInkBarWidth,
      themeInkBorderSize = token.themeInkBorderSize,
      motionDurationSlow = token.motionDurationSlow,
      motionEaseInOut = token.motionEaseInOut,
      motionEaseOut = token.motionEaseOut,
      menuItemPaddingInline = token.menuItemPaddingInline,
      motionDurationFast = token.motionDurationFast,
      themeColorTextHover = token.themeColorTextHover,
      lineType = token.lineType,
      colorBorderSecondary = token.colorBorderSecondary,
      themeColorDisabledText = token.themeColorDisabledText,
      themeColorDangerText = token.themeColorDangerText,
      themeColorDangerTextHover = token.themeColorDangerTextHover,
      themeColorDangerTextSelect = token.themeColorDangerTextSelect,
      themeColorDangerBgActive = token.themeColorDangerBgActive,
      themeColorDangerBgSelect = token.themeColorDangerBgSelect;
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-").concat(themeSuffix), (_$concat$concat3 = {
    color: themeColorText,
    background: themeColorBg
  }, (0, _defineProperty2["default"])(_$concat$concat3, "&".concat(componentCls, "-root:focus-visible"), (0, _extends2["default"])({}, accessibilityFocus(token))), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item-group-title"), {
    color: themeColorTextSecondary
  }), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-submenu-selected"), (0, _defineProperty2["default"])({}, "> ".concat(componentCls, "-submenu-title"), {
    color: themeColorTextSelect
  })), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item-disabled, ").concat(componentCls, "-submenu-disabled"), {
    color: "".concat(themeColorDisabledText, " !important")
  }), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item:hover, ").concat(componentCls, "-submenu-title:hover"), (0, _defineProperty2["default"])({}, "&:not(".concat(componentCls, "-item-selected):not(").concat(componentCls, "-submenu-selected)"), {
    color: themeColorTextHover
  })), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item:active, ").concat(componentCls, "-submenu-title:active"), {
    background: themeColorBgActive
  }), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item-danger"), (_$concat3 = {
    color: themeColorDangerText
  }, (0, _defineProperty2["default"])(_$concat3, "&".concat(componentCls, "-item:hover"), (0, _defineProperty2["default"])({}, "&:not(".concat(componentCls, "-item-selected):not(").concat(componentCls, "-submenu-selected)"), {
    color: themeColorDangerTextHover
  })), (0, _defineProperty2["default"])(_$concat3, "&".concat(componentCls, "-item:active"), {
    background: themeColorDangerBgActive
  }), _$concat3)), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item a"), {
    '&, &:hover': {
      color: 'inherit'
    }
  }), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item-selected"), (_$concat4 = {
    color: themeColorTextSelect
  }, (0, _defineProperty2["default"])(_$concat4, "&".concat(componentCls, "-item-danger"), {
    color: themeColorDangerTextSelect
  }), (0, _defineProperty2["default"])(_$concat4, "a, a:hover", {
    color: 'inherit'
  }), _$concat4)), (0, _defineProperty2["default"])(_$concat$concat3, "&:not(".concat(componentCls, "-horizontal) ").concat(componentCls, "-item-selected"), (0, _defineProperty2["default"])({
    backgroundColor: themeColorBgSelect
  }, "&".concat(componentCls, "-item-danger"), {
    backgroundColor: themeColorDangerBgSelect
  })), (0, _defineProperty2["default"])(_$concat$concat3, "".concat(componentCls, "-item, ").concat(componentCls, "-submenu-title"), {
    '&:focus-visible': (0, _extends2["default"])({}, accessibilityFocus(token))
  }), (0, _defineProperty2["default"])(_$concat$concat3, "&".concat(componentCls, "-submenu > ").concat(componentCls), {
    backgroundColor: themeColorBg
  }), (0, _defineProperty2["default"])(_$concat$concat3, "&".concat(componentCls, "-popup > ").concat(componentCls), {
    backgroundColor: themeColorBg
  }), (0, _defineProperty2["default"])(_$concat$concat3, "&".concat(componentCls, "-horizontal"), (0, _defineProperty2["default"])({}, "> ".concat(componentCls, "-item, > ").concat(componentCls, "-submenu"), (0, _defineProperty2["default"])({
    top: themeInkBorderSize,
    marginTop: -themeInkBorderSize,
    marginBottom: 0,
    '&::after': {
      position: 'absolute',
      insetInline: menuItemPaddingInline,
      bottom: 0,
      borderBottom: "".concat(themeInkBarHeight, "px solid transparent"),
      transition: "border-color ".concat(motionDurationSlow, " ").concat(motionEaseInOut),
      content: '""'
    }
  }, "&:hover, &-active, &-open, &-selected", {
    color: themeColorTextSelect,
    '&::after': {
      borderBottomColor: themeColorTextSelect
    }
  }))), (0, _defineProperty2["default"])(_$concat$concat3, "&".concat(componentCls, "-root"), (0, _defineProperty2["default"])({}, "&".concat(componentCls, "-inline, &").concat(componentCls, "-vertical"), {
    borderInlineEnd: "".concat(themeInkBorderSize, "px ").concat(lineType, " ").concat(colorBorderSecondary)
  })), (0, _defineProperty2["default"])(_$concat$concat3, "&".concat(componentCls, "-inline"), (_$concat8 = {}, (0, _defineProperty2["default"])(_$concat8, "".concat(componentCls, "-sub").concat(componentCls, "-inline"), {
    background: themeColorBgSecondary
  }), (0, _defineProperty2["default"])(_$concat8, "".concat(componentCls, "-item, ").concat(componentCls, "-submenu-title"), themeInkBorderSize ? {
    width: "calc(100% + ".concat(themeInkBorderSize, "px)")
  } : {}), (0, _defineProperty2["default"])(_$concat8, "".concat(componentCls, "-item"), (0, _defineProperty2["default"])({
    position: 'relative',
    '&::after': {
      position: 'absolute',
      insetBlock: 0,
      insetInlineEnd: 0,
      borderInlineEnd: "".concat(themeInkBarWidth, "px solid ").concat(themeColorTextSelect),
      transform: 'scaleY(0.0001)',
      opacity: 0,
      transition: ["transform ".concat(motionDurationFast, " ").concat(motionEaseOut), "opacity ".concat(motionDurationFast, " ").concat(motionEaseOut)].join(','),
      content: '""'
    }
  }, "&".concat(componentCls, "-item-danger"), {
    '&::after': {
      borderInlineEndColor: themeColorDangerTextSelect
    }
  })), (0, _defineProperty2["default"])(_$concat8, "".concat(componentCls, "-selected, ").concat(componentCls, "-item-selected"), {
    '&::after': {
      transform: 'scaleY(1)',
      opacity: 1,
      transition: ["transform ".concat(motionDurationFast, " ").concat(motionEaseInOut), "opacity ".concat(motionDurationFast, " ").concat(motionEaseInOut)].join(',')
    }
  }), _$concat8)), _$concat$concat3));
};

var _default = getThemeStyle;
exports["default"] = _default;