"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.genModalMaskStyle = exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends4 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _motion = require("../../style/motion");

var _theme = require("../../theme");

function box(position) {
  return {
    position: position,
    top: 0,
    insetInlineEnd: 0,
    bottom: 0,
    insetInlineStart: 0
  };
}

var genModalMaskStyle = function genModalMaskStyle(token) {
  var _$concat;

  var componentCls = token.componentCls;
  return [(0, _defineProperty2["default"])({}, "".concat(componentCls, "-root"), (_$concat = {}, (0, _defineProperty2["default"])(_$concat, "".concat(componentCls).concat(token.antCls, "-zoom-enter, ").concat(componentCls).concat(token.antCls, "-zoom-appear"), {
    // reset scale avoid mousePosition bug
    transform: 'none',
    opacity: 0,
    animationDuration: token.motionDurationSlow,
    // https://github.com/ant-design/ant-design/issues/11777
    userSelect: 'none'
  }), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-mask"), (0, _extends4["default"])((0, _extends4["default"])({}, box('fixed')), (0, _defineProperty2["default"])({
    zIndex: token.zIndexPopupBase,
    height: '100%',
    backgroundColor: token.colorBgMask
  }, "".concat(componentCls, "-hidden"), {
    display: 'none'
  }))), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-wrap"), (0, _extends4["default"])((0, _extends4["default"])({}, box('fixed')), {
    overflow: 'auto',
    outline: 0,
    WebkitOverflowScrolling: 'touch'
  })), _$concat)), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-root"), (0, _motion.initFadeMotion)(token))];
};

exports.genModalMaskStyle = genModalMaskStyle;

var genModalStyle = function genModalStyle(token) {
  var _mediaMaxWidth$, _$concat4, _extends3;

  var componentCls = token.componentCls;
  return [// ======================== Root =========================
  (0, _defineProperty2["default"])({}, "".concat(componentCls, "-root"), (_$concat4 = {}, (0, _defineProperty2["default"])(_$concat4, "".concat(componentCls, "-wrap"), {
    zIndex: token.zIndexPopupBase,
    position: 'fixed',
    inset: 0,
    overflow: 'auto',
    outline: 0,
    WebkitOverflowScrolling: 'touch'
  }), (0, _defineProperty2["default"])(_$concat4, "".concat(componentCls, "-wrap-rtl"), {
    direction: 'rtl'
  }), (0, _defineProperty2["default"])(_$concat4, "".concat(componentCls, "-centered"), (0, _defineProperty2["default"])({
    textAlign: 'center',
    '&::before': {
      display: 'inline-block',
      width: 0,
      height: '100%',
      verticalAlign: 'middle',
      content: '""'
    }
  }, componentCls, {
    top: 0,
    display: 'inline-block',
    paddingBottom: 0,
    textAlign: 'start',
    verticalAlign: 'middle'
  })), (0, _defineProperty2["default"])(_$concat4, "@media (max-width: ".concat(token.screenSMMax, ")"), (_mediaMaxWidth$ = {}, (0, _defineProperty2["default"])(_mediaMaxWidth$, componentCls, {
    maxWidth: 'calc(100vw - 16px)',
    margin: "".concat(token.marginXS, " auto")
  }), (0, _defineProperty2["default"])(_mediaMaxWidth$, "".concat(componentCls, "-centered"), (0, _defineProperty2["default"])({}, componentCls, {
    flex: 1
  })), _mediaMaxWidth$)), _$concat4)), // ======================== Modal ========================
  (0, _defineProperty2["default"])({}, componentCls, (0, _extends4["default"])((0, _extends4["default"])({}, (0, _theme.resetComponent)(token)), (_extends3 = {
    pointerEvents: 'none',
    position: 'relative',
    top: 100,
    width: 'auto',
    maxWidth: "calc(100vw - ".concat(token.margin * 2, "px)"),
    margin: '0 auto',
    paddingBottom: token.paddingLG
  }, (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-title"), {
    margin: 0,
    color: token.modalHeadingColor,
    fontWeight: token.fontWeightStrong,
    fontSize: token.modalHeaderTitleFontSize,
    lineHeight: token.modalHeaderTitleLineHeight,
    wordWrap: 'break-word'
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-content"), {
    position: 'relative',
    backgroundColor: token.modalContentBg,
    backgroundClip: 'padding-box',
    border: 0,
    borderRadius: token.controlRadius,
    boxShadow: token.boxShadow,
    pointerEvents: 'auto'
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-close"), {
    position: 'absolute',
    top: 0,
    insetInlineEnd: 0,
    zIndex: token.zIndexPopupBase + 10,
    padding: 0,
    color: token.modalCloseColor,
    fontWeight: token.fontWeightStrong,
    lineHeight: 1,
    textDecoration: 'none',
    background: 'transparent',
    border: 0,
    outline: 0,
    cursor: 'pointer',
    transition: "color ".concat(token.motionDurationSlow),
    '&-x': {
      display: 'block',
      width: token.modalHeaderCloseSize,
      height: token.modalHeaderCloseSize,
      fontSize: token.fontSizeLG,
      fontStyle: 'normal',
      lineHeight: "".concat(token.modalHeaderCloseSize, "px"),
      textAlign: 'center',
      textTransform: 'none',
      textRendering: 'auto'
    },
    '&:focus, &:hover': {
      color: token.modalIconHoverColor,
      textDecoration: 'none'
    }
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-header"), {
    padding: token.modalHeaderPadding,
    color: token.colorText,
    background: token.modalHeaderBg,
    borderBottom: "".concat(token.modalHeaderBorderWidth, "px ").concat(token.modalHeaderBorderStyle, " ").concat(token.modalHeaderBorderColorSplit),
    borderRadius: "".concat(token.controlRadius, "px ").concat(token.controlRadius, "px 0 0")
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-body"), {
    padding: token.modalBodyPadding,
    fontSize: token.fontSizeBase,
    lineHeight: token.lineHeight,
    wordWrap: 'break-word'
  }), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-footer"), (0, _defineProperty2["default"])({
    padding: "".concat(token.modalFooterPaddingVertical, "px ").concat(token.modalFooterPaddingHorizontal, "px"),
    textAlign: 'end',
    background: token.modalFooterBg,
    borderTop: "".concat(token.modalFooterBorderWidth, "px ").concat(token.modalFooterBorderStyle, " ").concat(token.modalFooterBorderColorSplit),
    borderRadius: "0 0 ".concat(token.controlRadius, "px ").concat(token.controlRadius, "px")
  }, "".concat(token.antCls, "-btn + ").concat(token.antCls, "-btn:not(").concat(token.antCls, "-dropdown-trigger)"), {
    marginBottom: 0,
    marginInlineStart: token.marginXS
  })), (0, _defineProperty2["default"])(_extends3, "".concat(componentCls, "-open"), {
    overflow: 'hidden'
  }), _extends3))), // ======================== Pure =========================
  (0, _defineProperty2["default"])({}, "".concat(componentCls, "-pure-panel"), {
    top: 'auto',
    padding: 0
  })];
};

var genModalConfirmStyle = function genModalConfirmStyle(token) {
  var _$concat7, _confirmComponentCls, _$concat9;

  var componentCls = token.componentCls;
  var confirmComponentCls = "".concat(componentCls, "-confirm");
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-root"), (_$concat9 = {}, (0, _defineProperty2["default"])(_$concat9, confirmComponentCls, (_confirmComponentCls = {
    '&-rtl': {
      direction: 'rtl'
    }
  }, (0, _defineProperty2["default"])(_confirmComponentCls, "".concat(token.antCls, "-modal-header"), {
    display: 'none'
  }), (0, _defineProperty2["default"])(_confirmComponentCls, "".concat(token.antCls, "-modal-body"), {
    padding: "".concat(token.padding * 2, "px ").concat(token.padding * 2, "px ").concat(token.paddingLG, "px")
  }), (0, _defineProperty2["default"])(_confirmComponentCls, "".concat(confirmComponentCls, "-body-wrapper"), (0, _extends4["default"])({}, (0, _theme.clearFix)())), (0, _defineProperty2["default"])(_confirmComponentCls, "".concat(confirmComponentCls, "-body"), (_$concat7 = {
    display: 'flex',
    flexWrap: 'wrap',
    alignItems: 'center'
  }, (0, _defineProperty2["default"])(_$concat7, "".concat(confirmComponentCls, "-title"), {
    flex: 1,
    display: 'block',
    // create BFC to avoid
    // https://user-images.githubusercontent.com/507615/37702510-ba844e06-2d2d-11e8-9b67-8e19be57f445.png
    overflow: 'hidden',
    color: token.colorTextHeading,
    fontWeight: token.fontWeightStrong,
    fontSize: token.modalHeaderTitleFontSize,
    lineHeight: token.modalHeaderTitleLineHeight
  }), (0, _defineProperty2["default"])(_$concat7, "".concat(confirmComponentCls, "-content"), {
    marginTop: token.marginXS,
    color: token.colorText,
    fontSize: token.fontSizeBase,
    flexBasis: '100%'
  }), (0, _defineProperty2["default"])(_$concat7, "> ".concat(token.iconCls), (0, _defineProperty2["default"])({
    flex: 'none',
    marginInlineEnd: token.margin,
    fontSize: token.modalConfirmIconSize
  }, "+ ".concat(confirmComponentCls, "-title + ").concat(confirmComponentCls, "-content"), {
    marginInlineStart: token.modalConfirmIconSize + token.margin
  })), _$concat7)), (0, _defineProperty2["default"])(_confirmComponentCls, "".concat(confirmComponentCls, "-btns"), (0, _defineProperty2["default"])({
    textAlign: 'end',
    marginTop: token.marginLG
  }, "".concat(token.antCls, "-btn + ").concat(token.antCls, "-btn"), {
    marginBottom: 0,
    marginInlineStart: token.marginXS
  })), _confirmComponentCls)), (0, _defineProperty2["default"])(_$concat9, "".concat(confirmComponentCls, "-error ").concat(confirmComponentCls, "-body > ").concat(token.iconCls), {
    color: token.colorError
  }), (0, _defineProperty2["default"])(_$concat9, "".concat(confirmComponentCls, "-warning ").concat(confirmComponentCls, "-body > ").concat(token.iconCls, ",\n        ").concat(confirmComponentCls, "-confirm ").concat(confirmComponentCls, "-body > ").concat(token.iconCls), {
    color: token.colorWarning
  }), (0, _defineProperty2["default"])(_$concat9, "".concat(confirmComponentCls, "-info ").concat(confirmComponentCls, "-body > ").concat(token.iconCls), {
    color: token.colorInfo
  }), (0, _defineProperty2["default"])(_$concat9, "".concat(confirmComponentCls, "-success ").concat(confirmComponentCls, "-body > ").concat(token.iconCls), {
    color: token.colorSuccess
  }), _$concat9));
};

var genRTLStyle = function genRTLStyle(token) {
  var componentCls = token.componentCls;
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-root"), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-wrap-rtl"), (0, _defineProperty2["default"])({
    direction: 'rtl'
  }, "".concat(componentCls, "-confirm-body"), {
    direction: 'rtl'
  })));
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Modal', function (token) {
  var headerPaddingVertical = token.padding;
  var headerFontSize = token.fontSizeHeading5;
  var headerLineHeight = token.lineHeightHeading5;
  var modalToken = (0, _theme.mergeToken)(token, {
    modalBodyPadding: token.paddingLG,
    modalHeaderBg: token.colorBgElevated,
    modalHeaderPadding: "".concat(headerPaddingVertical, "px ").concat(token.paddingLG, "px"),
    modalHeaderBorderWidth: token.controlLineWidth,
    modalHeaderBorderStyle: token.controlLineType,
    modalHeaderTitleLineHeight: headerLineHeight,
    modalHeaderTitleFontSize: headerFontSize,
    modalHeaderBorderColorSplit: token.colorSplit,
    modalHeaderCloseSize: headerLineHeight * headerFontSize + headerPaddingVertical * 2,
    modalContentBg: token.colorBgElevated,
    modalHeadingColor: token.colorTextHeading,
    modalCloseColor: token.colorTextSecondary,
    modalFooterBg: 'transparent',
    modalFooterBorderColorSplit: token.colorSplit,
    modalFooterBorderStyle: token.controlLineType,
    modalFooterPaddingVertical: token.paddingXS,
    modalFooterPaddingHorizontal: token.padding,
    modalFooterBorderWidth: token.controlLineWidth,
    modalConfirmTitleFontSize: token.fontSizeLG,
    modalIconHoverColor: token.colorActionHover,
    modalConfirmIconSize: token.fontSize * token.lineHeight
  });
  return [genModalStyle(modalToken), genModalConfirmStyle(modalToken), genRTLStyle(modalToken), genModalMaskStyle(modalToken), (0, _motion.initZoomMotion)(modalToken, 'zoom')];
});

exports["default"] = _default;