"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _cssinjs = require("@ant-design/cssinjs");

var _theme = require("../../theme");

var _placement = _interopRequireDefault(require("./placement"));

// deps-lint-skip-all
var genNotificationStyle = function genNotificationStyle(token) {
  var _extends2, _$concat, _noticeCls;

  var iconCls = token.iconCls,
      componentCls = token.componentCls,
      boxShadow = token.boxShadow,
      fontSizeLG = token.fontSizeLG,
      notificationMarginBottom = token.notificationMarginBottom,
      radiusBase = token.radiusBase,
      colorSuccess = token.colorSuccess,
      colorInfo = token.colorInfo,
      colorWarning = token.colorWarning,
      colorError = token.colorError,
      colorTextHeading = token.colorTextHeading,
      notificationBg = token.notificationBg,
      notificationPadding = token.notificationPadding,
      notificationMarginEdge = token.notificationMarginEdge,
      motionDurationMid = token.motionDurationMid,
      motionEaseInOut = token.motionEaseInOut,
      fontSizeBase = token.fontSizeBase,
      lineHeight = token.lineHeight,
      width = token.width;
  var noticeCls = "".concat(componentCls, "-notice");
  var notificationFadeIn = new _cssinjs.Keyframes('antNotificationFadeIn', {
    '0%': {
      left: {
        _skip_check_: true,
        value: width
      },
      opacity: 0
    },
    '100%': {
      left: {
        _skip_check_: true,
        value: 0
      },
      opacity: 1
    }
  });
  var notificationFadeOut = new _cssinjs.Keyframes('antNotificationFadeOut', {
    '0%': {
      maxHeight: token.animationMaxHeight,
      marginBottom: notificationMarginBottom,
      opacity: 1
    },
    '100%': {
      maxHeight: 0,
      marginBottom: 0,
      paddingTop: 0,
      paddingBottom: 0,
      opacity: 0
    }
  });
  return [// ============================ Holder ============================
  (0, _defineProperty2["default"])({}, componentCls, (0, _extends3["default"])((0, _extends3["default"])((0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    position: 'fixed',
    zIndex: token.zIndexPopup,
    marginInlineEnd: notificationMarginEdge
  }, (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-hook-holder"), {
    position: 'relative'
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(componentCls, "-top, &").concat(componentCls, "-bottom"), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-notice"), {
    marginInline: 'auto auto'
  })), (0, _defineProperty2["default"])(_extends2, "&".concat(componentCls, "-topLeft, &").concat(componentCls, "-bottomLeft"), (0, _defineProperty2["default"])({}, "".concat(componentCls, "-notice"), {
    marginInlineEnd: 'auto',
    marginInlineStart: 0
  })), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-fade-enter, ").concat(componentCls, "-fade-appear"), {
    animationDuration: token.motionDurationMid,
    animationTimingFunction: motionEaseInOut,
    animationFillMode: 'both',
    opacity: 0,
    animationPlayState: 'paused'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-fade-leave"), {
    animationTimingFunction: motionEaseInOut,
    animationFillMode: 'both',
    animationDuration: motionDurationMid,
    animationPlayState: 'paused'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-fade-enter").concat(componentCls, "-fade-enter-active, ").concat(componentCls, "-fade-appear").concat(componentCls, "-fade-appear-active"), {
    animationName: notificationFadeIn,
    animationPlayState: 'running'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-fade-leave").concat(componentCls, "-fade-leave-active"), {
    animationName: notificationFadeOut,
    animationPlayState: 'running'
  }), _extends2)), (0, _placement["default"])(token)), {
    // RTL
    '&-rtl': (0, _defineProperty2["default"])({
      direction: 'rtl'
    }, "".concat(componentCls, "-notice-btn"), {
      "float": 'left'
    })
  })), // ============================ Notice ============================
  (0, _defineProperty2["default"])({}, noticeCls, (_noticeCls = {
    position: 'relative',
    width: width,
    maxWidth: "calc(100vw - ".concat(notificationMarginEdge * 2, "px)"),
    marginBottom: notificationMarginBottom,
    marginInlineStart: 'auto',
    padding: notificationPadding,
    overflow: 'hidden',
    lineHeight: lineHeight,
    wordWrap: 'break-word',
    background: notificationBg,
    borderRadius: radiusBase,
    boxShadow: boxShadow
  }, (0, _defineProperty2["default"])(_noticeCls, "".concat(componentCls, "-close-icon"), {
    fontSize: fontSizeBase,
    cursor: 'pointer'
  }), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-message"), {
    marginBottom: token.marginXS,
    color: colorTextHeading,
    fontSize: fontSizeLG,
    lineHeight: token.lineHeightLG
  }), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-description"), {
    fontSize: fontSizeBase
  }), (0, _defineProperty2["default"])(_noticeCls, "&".concat(noticeCls, "-closable ").concat(noticeCls, "-message"), {
    paddingInlineEnd: token.paddingLG
  }), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-with-icon ").concat(noticeCls, "-message"), {
    marginBottom: token.marginXXS,
    marginInlineStart: token.marginXXL,
    fontSize: fontSizeLG
  }), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-with-icon ").concat(noticeCls, "-description"), {
    marginInlineStart: token.marginXXL,
    fontSize: fontSizeBase
  }), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-icon"), (_$concat = {
    position: 'absolute',
    marginInlineStart: token.marginXXS,
    fontSize: token.fontSizeLG * token.lineHeightLG
  }, (0, _defineProperty2["default"])(_$concat, "&-success".concat(iconCls), {
    color: colorSuccess
  }), (0, _defineProperty2["default"])(_$concat, "&-info".concat(iconCls), {
    color: colorInfo
  }), (0, _defineProperty2["default"])(_$concat, "&-warning".concat(iconCls), {
    color: colorWarning
  }), (0, _defineProperty2["default"])(_$concat, "&-error".concat(iconCls), {
    color: colorError
  }), _$concat)), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-close"), {
    position: 'absolute',
    top: token.notificationPaddingVertical,
    insetInlineEnd: token.notificationPaddingHorizontal,
    color: token.colorAction,
    outline: 'none',
    '&:hover': {
      color: token.colorActionHover
    }
  }), (0, _defineProperty2["default"])(_noticeCls, "".concat(noticeCls, "-btn"), {
    "float": 'right',
    marginTop: token.margin
  }), _noticeCls)), // ============================= Pure =============================
  (0, _defineProperty2["default"])({}, "".concat(noticeCls, "-pure-panel"), {
    margin: 0
  })];
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Notification', function (token) {
  var notificationPaddingVertical = token.padding;
  var notificationPaddingHorizontal = token.paddingLG;
  var notificationToken = (0, _theme.mergeToken)(token, {
    // default.css variables
    notificationBg: token.colorBgElevated,
    notificationPaddingVertical: notificationPaddingVertical,
    notificationPaddingHorizontal: notificationPaddingHorizontal,
    // index.css variables
    notificationPadding: "".concat(notificationPaddingVertical, "px ").concat(notificationPaddingHorizontal, "px"),
    notificationMarginBottom: token.margin,
    notificationMarginEdge: token.marginLG,
    animationMaxHeight: 150
  });
  return [genNotificationStyle(notificationToken)];
}, function (token) {
  return {
    zIndexPopup: token.zIndexPopupBase + 50,
    width: 384
  };
});

exports["default"] = _default;