"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _theme = require("../../theme");

// =============================== Base ===============================
var genBaseStyle = function genBaseStyle(token) {
  var _$concat, _componentCls;

  var componentCls = token.componentCls,
      paddingSM = token.paddingSM,
      padding = token.padding,
      paddingXXS = token.paddingXXS,
      iconCls = token.iconCls,
      zIndexPopup = token.zIndexPopup,
      colorText = token.colorText,
      colorWarning = token.colorWarning,
      marginXS = token.marginXS,
      marginXXS = token.marginXXS,
      fontSize = token.fontSize,
      lineHeight = token.lineHeight;
  return (0, _defineProperty2["default"])({}, componentCls, (_componentCls = {
    zIndex: zIndexPopup
  }, (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-inner-content"), {
    padding: "".concat(paddingSM, "px ").concat(padding, "px"),
    color: colorText
  }), (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-message"), (_$concat = {
    position: 'relative',
    padding: "".concat(paddingXXS, "px 0 ").concat(paddingSM, "px"),
    color: colorText,
    fontSize: fontSize,
    display: 'flex',
    flexWrap: 'nowrap',
    alignItems: 'start'
  }, (0, _defineProperty2["default"])(_$concat, "> ".concat(iconCls), {
    color: colorWarning,
    fontSize: fontSize,
    flex: 'none',
    lineHeight: 1,
    paddingTop: (Math.round(fontSize * lineHeight) - fontSize) / 2
  }), (0, _defineProperty2["default"])(_$concat, '&-title', {
    flex: 'auto',
    marginInlineStart: marginXS
  }), _$concat)), (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-buttons"), {
    marginBottom: marginXXS,
    textAlign: 'end',
    button: {
      marginInlineStart: marginXS
    }
  }), _componentCls));
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Popconfirm', function (token) {
  return genBaseStyle(token);
}, function (token) {
  var zIndexPopupBase = token.zIndexPopupBase;
  return {
    zIndexPopup: zIndexPopupBase + 60
  };
});

exports["default"] = _default;