"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _motion = require("../../style/motion");

var _theme = require("../../theme");

// deps-lint-skip-all
var genBaseStyle = function genBaseStyle(token) {
  var _extends2;

  var componentCls = token.componentCls,
      popoverBg = token.popoverBg,
      popoverColor = token.popoverColor,
      width = token.width,
      popoverPaddingHorizontal = token.popoverPaddingHorizontal,
      popoverTitlePaddingBlockTop = token.popoverTitlePaddingBlockTop,
      popoverTitlePaddingBlockBottom = token.popoverTitlePaddingBlockBottom,
      lineWidth = token.lineWidth,
      lineType = token.lineType,
      fontWeightStrong = token.fontWeightStrong,
      boxShadow = token.boxShadow,
      colorSplit = token.colorSplit,
      colorTextHeading = token.colorTextHeading,
      borderRadius = token.radiusBase,
      paddingSM = token.paddingSM,
      zIndexPopup = token.zIndexPopup;
  return [(0, _defineProperty2["default"])({}, componentCls, (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    position: 'absolute',
    top: 0,
    insetInlineStart: 0,
    zIndex: zIndexPopup,
    fontWeight: 'normal',
    whiteSpace: 'normal',
    textAlign: 'start',
    cursor: 'auto',
    userSelect: 'text',
    '&-rtl': {
      direction: 'rtl'
    },
    '&-hidden': {
      display: 'none'
    }
  }, (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-content"), {
    position: 'relative'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-inner"), {
    backgroundColor: popoverBg,
    backgroundClip: 'padding-box',
    borderRadius: borderRadius,
    boxShadow: boxShadow
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-title"), {
    minWidth: width,
    margin: 0,
    padding: "".concat(popoverTitlePaddingBlockTop, "px ").concat(popoverPaddingHorizontal, "px ").concat(popoverTitlePaddingBlockBottom, "px"),
    color: colorTextHeading,
    fontWeight: fontWeightStrong,
    borderBottom: "".concat(lineWidth, "px ").concat(lineType, " ").concat(colorSplit)
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-inner-content"), {
    padding: "".concat(paddingSM, "px ").concat(popoverPaddingHorizontal, "px"),
    color: popoverColor
  }), _extends2))), // Arrow Style
  (0, _theme.getArrowStyle)(token, token.colorBgElevated)];
};

var genColorStyle = function genColorStyle(token) {
  var componentCls = token.componentCls;
  return (0, _defineProperty2["default"])({}, componentCls, _theme.PresetColors.map(function (colorKey) {
    var _$concat$concat;

    var lightColor = token["".concat(colorKey, "-6")];
    return (0, _defineProperty2["default"])({}, "&".concat(componentCls, "-").concat(colorKey), (_$concat$concat = {}, (0, _defineProperty2["default"])(_$concat$concat, "".concat(componentCls, "-inner"), {
      backgroundColor: lightColor
    }), (0, _defineProperty2["default"])(_$concat$concat, "".concat(componentCls, "-arrow"), {
      background: 'transparent',
      '&:before': {
        backgroundColor: lightColor
      }
    }), _$concat$concat));
  }));
};

var _default = (0, _theme.genComponentStyleHook)('Popover', function (token) {
  var controlHeight = token.controlHeight,
      fontSize = token.fontSize,
      lineHeight = token.lineHeight,
      lineWidth = token.lineWidth,
      colorBgElevated = token.colorBgElevated;
  var titlePaddingBlockDist = controlHeight - Math.round(fontSize * lineHeight);
  var popoverToken = (0, _theme.mergeToken)(token, {
    popoverBg: colorBgElevated,
    popoverColor: token.colorText,
    popoverTitlePaddingBlockTop: titlePaddingBlockDist / 2,
    popoverTitlePaddingBlockBottom: titlePaddingBlockDist / 2 - lineWidth,
    popoverPaddingHorizontal: token.padding
  });
  return [genBaseStyle(popoverToken), genColorStyle(popoverToken), (0, _motion.initZoomMotion)(popoverToken, 'zoom-big')];
}, function (_ref4) {
  var zIndexPopupBase = _ref4.zIndexPopupBase;
  return {
    zIndexPopup: zIndexPopupBase + 30,
    width: 177
  };
});

exports["default"] = _default;