"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends4 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _tinycolor = require("@ctrl/tinycolor");

var _theme = require("../../theme");

var genSwitchSmallStyle = function genSwitchSmallStyle(token) {
  var _$concat, _$concat2;

  return (0, _defineProperty2["default"])({}, "&".concat(token.componentCls, "-small"), (_$concat2 = {
    minWidth: token.switchMinWidthSM,
    height: token.switchHeightSM,
    lineHeight: "".concat(token.switchHeightSM, "px")
  }, (0, _defineProperty2["default"])(_$concat2, "".concat(token.componentCls, "-inner"), {
    marginInlineStart: token.switchInnerMarginMaxSM,
    marginInlineEnd: token.switchInnerMarginMinSM,
    fontSize: token.fontSizeSM
  }), (0, _defineProperty2["default"])(_$concat2, "".concat(token.componentCls, "-handle"), {
    width: token.switchPinSizeSM,
    height: token.switchPinSizeSM
  }), (0, _defineProperty2["default"])(_$concat2, "".concat(token.componentCls, "-loading-icon"), {
    top: (token.switchPinSizeSM - token.switchLoadingIconSize) / 2,
    fontSize: token.switchLoadingIconSize
  }), (0, _defineProperty2["default"])(_$concat2, "&".concat(token.componentCls, "-checked"), (_$concat = {}, (0, _defineProperty2["default"])(_$concat, "".concat(token.componentCls, "-inner"), {
    marginInlineStart: token.switchInnerMarginMinSM,
    marginInlineEnd: token.switchInnerMarginMaxSM
  }), (0, _defineProperty2["default"])(_$concat, "".concat(token.componentCls, "-handle"), {
    insetInlineStart: "calc(100% - ".concat(token.switchPinSizeSM + token.switchPadding, "px)")
  }), _$concat)), _$concat2));
};

var genSwitchLoadingStyle = function genSwitchLoadingStyle(token) {
  var _ref2;

  return _ref2 = {}, (0, _defineProperty2["default"])(_ref2, "".concat(token.componentCls, "-loading-icon").concat(token.iconCls), {
    position: 'relative',
    top: (token.switchPinSize - token.fontSize) / 2,
    color: token.switchLoadingIconColor,
    verticalAlign: 'top'
  }), (0, _defineProperty2["default"])(_ref2, "&".concat(token.componentCls, "-checked ").concat(token.componentCls, "-loading-icon"), {
    color: token.switchColor
  }), _ref2;
};

var genSwitchHandleStyle = function genSwitchHandleStyle(token) {
  var _not$concat, _ref3;

  var switchHandleCls = "".concat(token.componentCls, "-handle");
  return _ref3 = {}, (0, _defineProperty2["default"])(_ref3, switchHandleCls, {
    position: 'absolute',
    top: token.switchPadding,
    insetInlineStart: token.switchPadding,
    width: token.switchPinSize,
    height: token.switchPinSize,
    transition: "all ".concat(token.switchDuration, " ease-in-out"),
    '&::before': {
      position: 'absolute',
      top: 0,
      insetInlineEnd: 0,
      bottom: 0,
      insetInlineStart: 0,
      backgroundColor: token.switchBg,
      borderRadius: token.switchPinSize / 2,
      boxShadow: token.switchHandleShadow,
      transition: "all ".concat(token.switchDuration, " ease-in-out"),
      content: '""'
    }
  }), (0, _defineProperty2["default"])(_ref3, "&".concat(token.componentCls, "-checked ").concat(switchHandleCls), {
    insetInlineStart: "calc(100% - ".concat(token.switchPinSize + token.switchPadding, "px)")
  }), (0, _defineProperty2["default"])(_ref3, "&:not(".concat(token.componentCls, "-disabled):active"), (_not$concat = {}, (0, _defineProperty2["default"])(_not$concat, "".concat(switchHandleCls, "::before"), {
    insetInlineEnd: token.switchHandleActiveInset,
    insetInlineStart: 0
  }), (0, _defineProperty2["default"])(_not$concat, "&".concat(token.componentCls, "-checked ").concat(switchHandleCls, "::before"), {
    insetInlineEnd: 0,
    insetInlineStart: token.switchHandleActiveInset
  }), _not$concat)), _ref3;
};

var genSwitchInnerStyle = function genSwitchInnerStyle(token) {
  var _ref4;

  var switchInnerCls = "".concat(token.componentCls, "-inner");
  return _ref4 = {}, (0, _defineProperty2["default"])(_ref4, switchInnerCls, {
    display: 'block',
    marginInlineEnd: token.switchInnerMarginMin,
    marginInlineStart: token.switchInnerMarginMax,
    color: token.colorTextLightSolid,
    fontSize: token.fontSizeSM,
    transition: "margin-inline-end ".concat(token.switchDuration, ", margin-inline-start ").concat(token.switchDuration)
  }), (0, _defineProperty2["default"])(_ref4, "&".concat(token.componentCls, "-checked ").concat(switchInnerCls), {
    marginInlineEnd: token.switchInnerMarginMax,
    marginInlineStart: token.switchInnerMarginMin
  }), _ref4;
};

var genSwitchStyle = function genSwitchStyle(token) {
  var _extends2;

  var componentCls = token.componentCls;
  return (0, _defineProperty2["default"])({}, componentCls, (0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])((0, _extends4["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    position: 'relative',
    display: 'inline-block',
    boxSizing: 'border-box',
    minWidth: token.switchMinWidth,
    height: token.switchHeight,
    lineHeight: "".concat(token.switchHeight, "px"),
    verticalAlign: 'middle',
    backgroundImage: "linear-gradient(to right, ".concat(token.colorTextDisabled, ", ").concat(token.colorTextDisabled, "), linear-gradient(to right, ").concat(token.colorBgContainer, ", ").concat(token.colorBgContainer, ")"),
    border: '0',
    borderRadius: 100,
    cursor: 'pointer',
    transition: "all ".concat(token.switchDuration),
    userSelect: 'none',
    '&:focus-visible': {
      outline: 0,
      boxShadow: "0 0 0 ".concat(token.controlOutlineWidth, "px ").concat(token.controlTmpOutline)
    }
  }, (0, _defineProperty2["default"])(_extends2, "&".concat(token.componentCls, "-checked:focus-visible"), {
    boxShadow: "0 0 0 ".concat(token.controlOutlineWidth, "px ").concat(token.colorPrimaryOutline)
  }), (0, _defineProperty2["default"])(_extends2, '&:focus:hover', {
    boxShadow: 'none'
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(token.componentCls, "-checked"), {
    background: token.switchColor
  }), (0, _defineProperty2["default"])(_extends2, "&".concat(token.componentCls, "-loading, &").concat(token.componentCls, "-disabled"), {
    cursor: 'not-allowed',
    opacity: token.switchDisabledOpacity,
    '*': {
      boxShadow: 'none',
      cursor: 'not-allowed'
    }
  }), _extends2)), genSwitchInnerStyle(token)), genSwitchHandleStyle(token)), genSwitchLoadingStyle(token)), genSwitchSmallStyle(token)), (0, _defineProperty2["default"])({}, "&".concat(token.componentCls, "-rtl"), {
    direction: 'rtl'
  })));
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Switch', function (token) {
  var switchHeight = token.fontSize * token.lineHeight;
  var switchHeightSM = token.controlHeight / 2;
  var switchPadding = token.paddingXXS / 2;
  var switchPinSize = switchHeight - switchPadding * 2;
  var switchPinSizeSM = switchHeightSM - switchPadding * 2;
  var switchToken = (0, _theme.mergeToken)(token, {
    switchMinWidth: switchPinSize * 2 + switchPadding * 4,
    switchHeight: switchHeight,
    switchDuration: token.motionDurationMid,
    switchColor: token.colorPrimary,
    switchDisabledOpacity: token.opacityLoading,
    switchInnerMarginMin: switchPinSize / 2,
    switchInnerMarginMax: switchPinSize + switchPadding + token.paddingXXS,
    switchPadding: switchPadding,
    switchPinSize: switchPinSize,
    switchBg: token.colorBgContainer,
    switchMinWidthSM: switchPinSizeSM * 2 + switchPadding * 2,
    switchHeightSM: switchHeightSM,
    switchInnerMarginMinSM: switchPinSizeSM / 2,
    switchInnerMarginMaxSM: switchPinSizeSM + switchPadding + token.paddingXXS,
    switchPinSizeSM: switchPinSizeSM,
    switchHandleShadow: "0 2px 4px 0 ".concat(new _tinycolor.TinyColor('#00230b').setAlpha(0.2).toRgbString()),
    switchLoadingIconSize: token.fontSizeIcon * 0.75,
    switchLoadingIconColor: "rgba(0, 0, 0, ".concat(token.opacityLoading, ")"),
    switchHandleActiveInset: '-30%'
  });
  return [genSwitchStyle(switchToken)];
});

exports["default"] = _default;