"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _theme = require("../../theme");

var genExpandStyle = function genExpandStyle(token) {
  var _extends2, _$concat;

  var componentCls = token.componentCls,
      antCls = token.antCls,
      checkboxSize = token.controlInteractiveSize,
      motionDurationSlow = token.motionDurationSlow,
      controlLineWidth = token.controlLineWidth,
      paddingXXS = token.paddingXXS,
      paddingXS = token.paddingXS,
      controlLineType = token.controlLineType,
      tableBorderColor = token.tableBorderColor,
      tableExpandIconBg = token.tableExpandIconBg,
      tableExpandColumnWidth = token.tableExpandColumnWidth,
      radiusBase = token.radiusBase,
      tablePaddingVertical = token.tablePaddingVertical,
      tablePaddingHorizontal = token.tablePaddingHorizontal,
      tableExpandedRowBg = token.tableExpandedRowBg;
  var halfInnerSize = checkboxSize / 2 - controlLineWidth; // must be odd number, unless it cannot align center

  var expandIconSize = halfInnerSize * 2 + controlLineWidth * 3;
  var tableBorder = "".concat(controlLineWidth, "px ").concat(controlLineType, " ").concat(tableBorderColor);
  var expandIconLineOffset = paddingXXS - controlLineWidth;
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-wrapper"), (_$concat = {}, (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-expand-icon-col"), {
    width: tableExpandColumnWidth
  }), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-row-expand-icon-cell"), {
    textAlign: 'center'
  }), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-row-indent"), {
    height: 1
  }), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-row-expand-icon"), (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.operationUnit)(token)), (_extends2 = {
    position: 'relative',
    display: 'inline-flex',
    verticalAlign: 'text-top',
    boxSizing: 'border-box',
    width: expandIconSize,
    height: expandIconSize,
    padding: 0,
    color: 'inherit',
    lineHeight: "".concat(expandIconSize, "px"),
    background: tableExpandIconBg,
    border: tableBorder,
    borderRadius: radiusBase,
    outline: 'none',
    transform: "scale(".concat(checkboxSize / expandIconSize, ")"),
    transition: "all ".concat(motionDurationSlow),
    userSelect: 'none'
  }, (0, _defineProperty2["default"])(_extends2, "&:focus, &:hover, &:active", {
    borderColor: 'currentcolor'
  }), (0, _defineProperty2["default"])(_extends2, "&::before, &::after", {
    position: 'absolute',
    background: 'currentcolor',
    transition: "transform ".concat(motionDurationSlow, " ease-out"),
    content: '""'
  }), (0, _defineProperty2["default"])(_extends2, '&::before', {
    top: halfInnerSize,
    insetInlineEnd: expandIconLineOffset,
    insetInlineStart: expandIconLineOffset,
    height: controlLineWidth
  }), (0, _defineProperty2["default"])(_extends2, '&::after', {
    top: expandIconLineOffset,
    bottom: expandIconLineOffset,
    insetInlineStart: halfInnerSize,
    width: controlLineWidth,
    transform: 'rotate(90deg)'
  }), (0, _defineProperty2["default"])(_extends2, '&-collapsed::before', {
    transform: 'rotate(-180deg)'
  }), (0, _defineProperty2["default"])(_extends2, '&-collapsed::after', {
    transform: 'rotate(0deg)'
  }), (0, _defineProperty2["default"])(_extends2, '&-spaced', {
    '&::before, &::after': {
      display: 'none',
      content: 'none'
    },
    background: 'transparent',
    border: 0,
    visibility: 'hidden'
  }), _extends2))), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-row-indent + ").concat(componentCls, "-row-expand-icon"), {
    marginInlineEnd: paddingXS
  }), (0, _defineProperty2["default"])(_$concat, "tr".concat(componentCls, "-expanded-row"), (0, _defineProperty2["default"])({
    '&, &:hover': {
      '> td': {
        background: tableExpandedRowBg
      }
    }
  }, "".concat(antCls, "-descriptions-view"), {
    display: 'flex',
    table: {
      flex: 'auto',
      width: 'auto'
    }
  })), (0, _defineProperty2["default"])(_$concat, "".concat(componentCls, "-expanded-row-fixed"), {
    position: 'relative',
    margin: "-".concat(tablePaddingVertical, "px -").concat(tablePaddingHorizontal, "px"),
    padding: "".concat(tablePaddingVertical, "px ").concat(tablePaddingHorizontal, "px")
  }), _$concat));
};

var _default = genExpandStyle;
exports["default"] = _default;