"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _tinycolor = require("@ctrl/tinycolor");

var _theme = require("../../theme");

var _bordered = _interopRequireDefault(require("./bordered"));

var _ellipsis = _interopRequireDefault(require("./ellipsis"));

var _empty = _interopRequireDefault(require("./empty"));

var _expand = _interopRequireDefault(require("./expand"));

var _filter = _interopRequireDefault(require("./filter"));

var _fixed = _interopRequireDefault(require("./fixed"));

var _pagination = _interopRequireDefault(require("./pagination"));

var _radius = _interopRequireDefault(require("./radius"));

var _rtl = _interopRequireDefault(require("./rtl"));

var _selection = _interopRequireDefault(require("./selection"));

var _size = _interopRequireDefault(require("./size"));

var _sorter = _interopRequireDefault(require("./sorter"));

var _sticky = _interopRequireDefault(require("./sticky"));

var _summary = _interopRequireDefault(require("./summary"));

var genTableStyle = function genTableStyle(token) {
  var _tr, _extends2;

  var componentCls = token.componentCls,
      fontWeightStrong = token.fontWeightStrong,
      tablePaddingVertical = token.tablePaddingVertical,
      tablePaddingHorizontal = token.tablePaddingHorizontal,
      controlLineWidth = token.controlLineWidth,
      controlLineType = token.controlLineType,
      tableBorderColor = token.tableBorderColor,
      tableFontSize = token.tableFontSize,
      tableBg = token.tableBg,
      tableRadius = token.tableRadius,
      tableHeaderTextColor = token.tableHeaderTextColor,
      motionDurationSlow = token.motionDurationSlow,
      tableHeaderBg = token.tableHeaderBg,
      tableHeaderCellSplitColor = token.tableHeaderCellSplitColor,
      tableRowHoverBg = token.tableRowHoverBg,
      tableSelectedRowBg = token.tableSelectedRowBg,
      tableSelectedRowHoverBg = token.tableSelectedRowHoverBg,
      tableFooterTextColor = token.tableFooterTextColor,
      tableFooterBg = token.tableFooterBg;
  var tableBorder = "".concat(controlLineWidth, "px ").concat(controlLineType, " ").concat(tableBorderColor);
  return (0, _defineProperty2["default"])({}, "".concat(componentCls, "-wrapper"), (0, _extends3["default"])((0, _extends3["default"])({
    clear: 'both',
    maxWidth: '100%'
  }, (0, _theme.clearFix)()), (_extends2 = {}, (0, _defineProperty2["default"])(_extends2, componentCls, (0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), {
    fontSize: tableFontSize,
    background: tableBg,
    borderRadius: tableRadius
  })), (0, _defineProperty2["default"])(_extends2, "table", {
    width: '100%',
    textAlign: 'start',
    borderRadius: "".concat(tableRadius, "px ").concat(tableRadius, "px 0 0"),
    borderCollapse: 'separate',
    borderSpacing: 0
  }), (0, _defineProperty2["default"])(_extends2, "\n          ".concat(componentCls, "-thead > tr > th,\n          ").concat(componentCls, "-tbody > tr > td,\n          tfoot > tr > th,\n          tfoot > tr > td\n        "), {
    position: 'relative',
    padding: "".concat(tablePaddingVertical, "px ").concat(tablePaddingHorizontal, "px"),
    overflowWrap: 'break-word'
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-title"), {
    padding: "".concat(tablePaddingVertical, "px ").concat(tablePaddingHorizontal, "px")
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-thead"), {
    '> tr > th': (0, _defineProperty2["default"])({
      position: 'relative',
      color: tableHeaderTextColor,
      fontWeight: fontWeightStrong,
      textAlign: 'start',
      background: tableHeaderBg,
      borderBottom: tableBorder,
      transition: "background ".concat(motionDurationSlow, " ease"),
      "&[colspan]:not([colspan='1'])": {
        textAlign: 'center'
      }
    }, "&:not(:last-child):not(".concat(componentCls, "-selection-column):not(").concat(componentCls, "-row-expand-icon-cell):not([colspan])::before"), {
      position: 'absolute',
      top: '50%',
      insetInlineEnd: 0,
      width: 1,
      height: '1.6em',
      backgroundColor: tableHeaderCellSplitColor,
      transform: 'translateY(-50%)',
      transition: "background-color ".concat(motionDurationSlow),
      content: '""'
    }),
    '> tr:not(:last-child) > th[colspan]': {
      borderBottom: 0
    }
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-tbody"), {
    '> tr': (_tr = {
      '> td': (0, _defineProperty2["default"])({
        borderBottom: tableBorder,
        transition: "background ".concat(motionDurationSlow)
      }, "\n              > ".concat(componentCls, "-wrapper:only-child,\n              > ").concat(componentCls, "-expanded-row-fixed > ").concat(componentCls, "-wrapper:only-child\n            "), (0, _defineProperty2["default"])({}, componentCls, (0, _defineProperty2["default"])({
        marginBlock: "-".concat(tablePaddingVertical, "px"),
        marginInline: "".concat(token.tableExpandColumnWidth - tablePaddingHorizontal, "px -").concat(tablePaddingHorizontal, "px")
      }, "".concat(componentCls, "-tbody > tr:last-child > td"), {
        borderBottom: 0,
        '&:first-child, &:last-child': {
          borderRadius: 0
        }
      })))
    }, (0, _defineProperty2["default"])(_tr, "\n            &".concat(componentCls, "-row:hover > td,\n            > td").concat(componentCls, "-cell-row-hover\n          "), {
      background: tableRowHoverBg
    }), (0, _defineProperty2["default"])(_tr, "&".concat(componentCls, "-row-selected"), {
      '> td': {
        background: tableSelectedRowBg
      },
      '&:hover > td': {
        background: tableSelectedRowHoverBg
      }
    }), _tr)
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-footer"), {
    padding: "".concat(tablePaddingVertical, "px ").concat(tablePaddingHorizontal, "px"),
    color: tableFooterTextColor,
    background: tableFooterBg
  }), _extends2)));
}; // ============================== Export ==============================


var _default = (0, _theme.genComponentStyleHook)('Table', function (token) {
  var controlItemBgActive = token.controlItemBgActive,
      controlItemBgActiveHover = token.controlItemBgActiveHover,
      colorTextPlaceholder = token.colorTextPlaceholder,
      colorTextHeading = token.colorTextHeading,
      colorSplit = token.colorSplit,
      fontSize = token.fontSize,
      padding = token.padding,
      paddingXS = token.paddingXS,
      paddingSM = token.paddingSM,
      controlHeight = token.controlHeight,
      colorBgContainerSecondary = token.colorBgContainerSecondary,
      colorAction = token.colorAction,
      colorActionHover = token.colorActionHover,
      opacityLoading = token.opacityLoading,
      colorBgContainer = token.colorBgContainer,
      colorBgContent = token.colorBgContent,
      radiusBase = token.radiusBase,
      colorBgFillTmp = token.colorBgFillTmp,
      checkboxSize = token.controlInteractiveSize;
  var baseColorAction = new _tinycolor.TinyColor(colorAction);
  var baseColorActionHover = new _tinycolor.TinyColor(colorActionHover);
  var tableSelectedRowBg = controlItemBgActive;
  var zIndexTableFixed = 2;
  var tableToken = (0, _theme.mergeToken)(token, {
    tableFontSize: fontSize,
    tableBg: colorBgContainer,
    tableRadius: radiusBase,
    tablePaddingVertical: padding,
    tablePaddingHorizontal: padding,
    tablePaddingVerticalMiddle: paddingSM,
    tablePaddingHorizontalMiddle: paddingXS,
    tablePaddingVerticalSmall: paddingXS,
    tablePaddingHorizontalSmall: paddingXS,
    tableBorderColor: colorSplit,
    tableHeaderTextColor: colorTextHeading,
    tableHeaderBg: colorBgContainerSecondary,
    tableFooterTextColor: colorTextHeading,
    tableFooterBg: colorBgContainerSecondary,
    tableHeaderCellSplitColor: colorSplit,
    tableHeaderSortBg: colorBgContent,
    tableHeaderSortHoverBg: colorBgFillTmp,
    tableHeaderIconColor: baseColorAction.clone().setAlpha(baseColorAction.getAlpha() * opacityLoading).toRgbString(),
    tableHeaderIconColorHover: baseColorActionHover.clone().setAlpha(baseColorActionHover.getAlpha() * opacityLoading).toRgbString(),
    tableBodySortBg: colorBgContainerSecondary,
    tableFixedHeaderSortActiveBg: colorBgContent,
    tableHeaderFilterActiveBg: colorBgFillTmp,
    tableFilterDropdownBg: colorBgContainer,
    tableRowHoverBg: colorBgContainerSecondary,
    tableSelectedRowBg: tableSelectedRowBg,
    tableSelectedRowHoverBg: controlItemBgActiveHover,
    zIndexTableFixed: zIndexTableFixed,
    zIndexTableSticky: zIndexTableFixed + 1,
    tableFontSizeMiddle: fontSize,
    tableFontSizeSmall: fontSize,
    tableSelectionColumnWidth: controlHeight,
    tableExpandIconBg: colorBgContainer,
    tableExpandColumnWidth: checkboxSize + 2 * token.padding,
    tableExpandedRowBg: colorBgContainerSecondary,
    // Dropdown
    tableFilterDropdownWidth: 120,
    tableFilterDropdownHeight: 264,
    tableFilterDropdownSearchWidth: 140,
    // Virtual Scroll Bar
    tableScrollThumbSize: 8,
    tableScrollThumbBg: colorTextPlaceholder,
    tableScrollThumbBgHover: colorTextHeading,
    tableScrollBg: colorSplit
  });
  return [genTableStyle(tableToken), (0, _pagination["default"])(tableToken), (0, _summary["default"])(tableToken), (0, _sorter["default"])(tableToken), (0, _filter["default"])(tableToken), (0, _bordered["default"])(tableToken), (0, _radius["default"])(tableToken), (0, _expand["default"])(tableToken), (0, _summary["default"])(tableToken), (0, _empty["default"])(tableToken), (0, _selection["default"])(tableToken), (0, _fixed["default"])(tableToken), (0, _sticky["default"])(tableToken), (0, _ellipsis["default"])(tableToken), (0, _size["default"])(tableToken), (0, _rtl["default"])(tableToken)];
});

exports["default"] = _default;