"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DesignTokenContext = void 0;
Object.defineProperty(exports, "PresetColors", {
  enumerable: true,
  get: function get() {
    return _interface.PresetColors;
  }
});
Object.defineProperty(exports, "clearFix", {
  enumerable: true,
  get: function get() {
    return _util.clearFix;
  }
});
Object.defineProperty(exports, "genComponentStyleHook", {
  enumerable: true,
  get: function get() {
    return _genComponentStyleHook["default"];
  }
});
Object.defineProperty(exports, "getArrowStyle", {
  enumerable: true,
  get: function get() {
    return _placementArrow["default"];
  }
});
Object.defineProperty(exports, "mergeToken", {
  enumerable: true,
  get: function get() {
    return _statistic.merge;
  }
});
Object.defineProperty(exports, "operationUnit", {
  enumerable: true,
  get: function get() {
    return _util.operationUnit;
  }
});
Object.defineProperty(exports, "resetComponent", {
  enumerable: true,
  get: function get() {
    return _util.resetComponent;
  }
});
Object.defineProperty(exports, "resetIcon", {
  enumerable: true,
  get: function get() {
    return _util.resetIcon;
  }
});
Object.defineProperty(exports, "roundedArrow", {
  enumerable: true,
  get: function get() {
    return _util.roundedArrow;
  }
});
Object.defineProperty(exports, "statistic", {
  enumerable: true,
  get: function get() {
    return _statistic.statistic;
  }
});
Object.defineProperty(exports, "statisticToken", {
  enumerable: true,
  get: function get() {
    return _statistic["default"];
  }
});
Object.defineProperty(exports, "useStyleRegister", {
  enumerable: true,
  get: function get() {
    return _cssinjs.useStyleRegister;
  }
});
exports.useToken = useToken;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _cssinjs = require("@ant-design/cssinjs");

var _react = _interopRequireDefault(require("react"));

var _version = _interopRequireDefault(require("../version"));

var _interface = require("./interface");

var _default = _interopRequireDefault(require("./themes/default"));

var _seed = _interopRequireDefault(require("./themes/seed"));

var _util = require("./util");

var _alias = _interopRequireDefault(require("./util/alias"));

var _genComponentStyleHook = _interopRequireDefault(require("./util/genComponentStyleHook"));

var _placementArrow = _interopRequireDefault(require("./util/placementArrow"));

var _statistic = _interopRequireWildcard(require("./util/statistic"));

var defaultTheme = new _cssinjs.Theme(_default["default"]);

// ================================ Context =================================
var DesignTokenContext = /*#__PURE__*/_react["default"].createContext({
  token: _seed["default"]
}); // ================================== Hook ==================================
// In dev env, we refresh salt per hour to avoid user use this
// Note: Do not modify this to real time update which will make debug harder


exports.DesignTokenContext = DesignTokenContext;
var saltPrefix = process.env.NODE_ENV === 'production' ? _version["default"] : "".concat(_version["default"], "-").concat(new Date().getHours());

function useToken() {
  var _React$useContext = _react["default"].useContext(DesignTokenContext),
      rootDesignToken = _React$useContext.token,
      override = _React$useContext.override,
      hashed = _React$useContext.hashed,
      theme = _React$useContext.theme;

  var salt = "".concat(saltPrefix, "-").concat(hashed || '');
  var mergedTheme = theme || defaultTheme;

  var _useCacheToken = (0, _cssinjs.useCacheToken)(mergedTheme, [_seed["default"], rootDesignToken], {
    salt: salt,
    override: override,
    formatToken: _alias["default"]
  }),
      _useCacheToken2 = (0, _slicedToArray2["default"])(_useCacheToken, 2),
      token = _useCacheToken2[0],
      hashId = _useCacheToken2[1];

  return [mergedTheme, token, hashed ? hashId : ''];
}