"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = derivative;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _colors = require("@ant-design/colors");

var _tinycolor = require("@ctrl/tinycolor");

var _seed = require("../seed");

var _genColorMapToken = _interopRequireDefault(require("../shared/genColorMapToken"));

var _genCommonMapToken = _interopRequireDefault(require("../shared/genCommonMapToken"));

var _palettes = require("./palettes");

function derivative(token) {
  var colorPrimary = token.colorPrimary,
      colorSuccess = token.colorSuccess,
      colorWarning = token.colorWarning,
      colorError = token.colorError,
      colorInfo = token.colorInfo;
  var colorPalettes = Object.keys(_seed.defaultPresetColors).map(function (colorKey) {
    var colors = (0, _colors.generate)(token[colorKey], {
      theme: 'dark'
    });
    return new Array(10).fill(1).reduce(function (prev, _, i) {
      prev["".concat(colorKey, "-").concat(i + 1)] = colors[i];
      return prev;
    }, {});
  }).reduce(function (prev, cur) {
    prev = (0, _extends2["default"])((0, _extends2["default"])({}, prev), cur);
    return prev;
  }, {});
  var primaryColors = (0, _palettes.generatePrimaryPalettes)(colorPrimary);
  var successColors = (0, _palettes.generateSuccessPalettes)(colorSuccess);
  var warningColors = (0, _palettes.generateWarningPalettes)(colorWarning);
  var errorColors = (0, _palettes.generateErrorPalettes)(colorError);
  var infoColors = (0, _palettes.generateInfoPalettes)(colorInfo);
  var bgColors = (0, _palettes.generateBgPalettes)('#000');
  var textColors = (0, _palettes.generateTextAlphaPalettes)('#fff');
  return (0, _extends2["default"])((0, _extends2["default"])((0, _extends2["default"])((0, _extends2["default"])((0, _extends2["default"])({}, token), colorPalettes), (0, _genColorMapToken["default"])({
    primaryPalettes: primaryColors,
    successPalettes: successColors,
    warningPalettes: warningColors,
    errorPalettes: errorColors,
    infoPalettes: infoColors,
    bgPalettes: bgColors,
    textAlphaPalettes: textColors
  })), {
    colorPrimaryOutline: new _tinycolor.TinyColor(colorPrimary).setAlpha(0.2).toRgbString(),
    colorErrorOutline: new _tinycolor.TinyColor(colorError).setAlpha(0.2).toRgbString(),
    colorWarningOutline: new _tinycolor.TinyColor(colorWarning).setAlpha(0.2).toRgbString()
  }), (0, _genCommonMapToken["default"])(token));
}