"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateBgPalettes = generateBgPalettes;
exports.generateErrorPalettes = generateErrorPalettes;
exports.generateInfoPalettes = generateInfoPalettes;
exports.generatePrimaryPalettes = generatePrimaryPalettes;
exports.generateSuccessPalettes = generateSuccessPalettes;
exports.generateTextAlphaPalettes = generateTextAlphaPalettes;
exports.generateWarningPalettes = generateWarningPalettes;

var _colors = require("@ant-design/colors");

var _colorAlgorithm = require("./colorAlgorithm");

function generatePrimaryPalettes(primaryBaseColor) {
  var primaryColors = (0, _colors.generate)(primaryBaseColor);
  return {
    0: '#0e161f',
    1: primaryColors[0],
    2: primaryColors[1],
    3: primaryColors[2],
    4: primaryColors[3],
    5: primaryColors[4],
    6: primaryColors[5],
    7: primaryColors[6]
  };
}

function generateSuccessPalettes(successBaseColor) {
  var successColors = (0, _colors.generate)(successBaseColor);
  return {
    1: successColors[0],
    3: successColors[2],
    6: successColors[5]
  };
}

function generateErrorPalettes(errorBaseColor) {
  var errorColors = (0, _colors.generate)(errorBaseColor);
  return {
    1: errorColors[0],
    3: errorColors[2],
    5: errorColors[4],
    6: errorColors[5],
    7: errorColors[6]
  };
}

function generateWarningPalettes(warningBaseColor) {
  var warningColors = (0, _colors.generate)(warningBaseColor);
  return {
    1: warningColors[0],
    3: warningColors[2],
    5: warningColors[4],
    6: warningColors[5],
    7: warningColors[6]
  };
}

function generateInfoPalettes(infoBaseColor) {
  var infoColors = (0, _colors.generate)(infoBaseColor);
  return {
    1: infoColors[0],
    3: infoColors[2],
    6: infoColors[5]
  };
}

function generateBgPalettes(bgBaseColor) {
  return {
    26: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 15),
    'light-2': (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 2),
    'light-10': (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 10),
    'light-12': (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 12),
    19: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 6),
    15: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 4),
    12: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 0),
    8: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 0),
    0: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 4),
    base: (0, _colorAlgorithm.getSolidColor)(bgBaseColor, 0)
  };
}

function generateTextAlphaPalettes(textBaseColor) {
  return {
    85: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.85),
    'light-75': (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.75),
    65: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.65),
    45: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.45),
    30: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.25),
    25: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.25),
    // 从 12 往下基本上就是偏背景和装饰性元素了
    12: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.06),
    8: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.04),
    4: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.03),
    3: (0, _colorAlgorithm.getAlphaColor)(textBaseColor, 0.02)
  };
}