"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = genComponentStyleHook;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _cssinjs = require("@ant-design/cssinjs");

var _react = require("react");

var _context = require("../../config-provider/context");

var _index = require("../index");

function genComponentStyleHook(component, styleFn, getDefaultToken) {
  return function (prefixCls) {
    var _useToken = (0, _index.useToken)(),
        _useToken2 = (0, _slicedToArray2["default"])(_useToken, 3),
        theme = _useToken2[0],
        token = _useToken2[1],
        hashId = _useToken2[2];

    var _useContext = (0, _react.useContext)(_context.ConfigContext),
        getPrefixCls = _useContext.getPrefixCls,
        iconPrefixCls = _useContext.iconPrefixCls;

    var rootPrefixCls = getPrefixCls();
    return [(0, _cssinjs.useStyleRegister)({
      theme: theme,
      token: token,
      hashId: hashId,
      path: [component, prefixCls]
    }, function () {
      var _statisticToken = (0, _index.statisticToken)(token),
          proxyToken = _statisticToken.token,
          flush = _statisticToken.flush;

      var defaultComponentToken = typeof getDefaultToken === 'function' ? getDefaultToken(proxyToken) : getDefaultToken;
      var overrideComponentToken = token[component]; // Only merge token specified in interface

      var mergedComponentToken = (0, _extends2["default"])({}, defaultComponentToken);

      if (overrideComponentToken) {
        Object.keys(mergedComponentToken).forEach(function (key) {
          var _a;

          mergedComponentToken[key] = (_a = overrideComponentToken[key]) !== null && _a !== void 0 ? _a : mergedComponentToken[key];
        });
      }

      var mergedToken = (0, _index.mergeToken)(proxyToken, {
        componentCls: ".".concat(prefixCls),
        prefixCls: prefixCls,
        iconCls: ".".concat(iconPrefixCls),
        antCls: ".".concat(rootPrefixCls)
      }, mergedComponentToken);
      var styleInterpolation = styleFn(mergedToken, {
        hashId: hashId,
        prefixCls: prefixCls,
        rootPrefixCls: rootPrefixCls,
        iconPrefixCls: iconPrefixCls
      });
      flush(component, mergedComponentToken);
      return styleInterpolation;
    }), hashId];
  };
}