"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getArrowStyle;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _roundedArrow = require("./roundedArrow");

function connectArrowCls(classList) {
  var showArrowCls = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  return classList.map(function (cls) {
    return "".concat(showArrowCls).concat(cls);
  }).join(',');
}

function getArrowStyle(token, colorBg, showArrowCls) {
  var _componentCls;

  var linearGradient = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  var componentCls = token.componentCls,
      sizePopupArrow = token.sizePopupArrow,
      marginXXS = token.marginXXS;
  var dropdownArrowOffset = sizePopupArrow / Math.sqrt(2) * 2;
  var dropdownArrowDistance = sizePopupArrow + marginXXS;
  return (0, _defineProperty2["default"])({}, componentCls, (_componentCls = {}, (0, _defineProperty2["default"])(_componentCls, "".concat(componentCls, "-arrow"), [linearGradient ? {
    // Use linear-gradient to prevent arrow from covering text
    background: "linear-gradient(135deg, transparent 49%, ".concat(colorBg, " 50%)")
  } : {}, (0, _extends2["default"])((0, _extends2["default"])({
    position: 'absolute',
    zIndex: 1,
    display: 'block',
    width: sizePopupArrow,
    height: sizePopupArrow
  }, (0, _roundedArrow.roundedArrow)(sizePopupArrow, 5, colorBg)), {
    '&:before': {
      background: colorBg
    }
  })]), (0, _defineProperty2["default"])(_componentCls, ["&-placement-top ".concat(componentCls, "-arrow"), "&-placement-topLeft ".concat(componentCls, "-arrow"), "&-placement-topRight ".concat(componentCls, "-arrow")].join(','), {
    bottom: 0,
    boxShadow: token.boxShadowPopoverArrow,
    transform: 'translateY(50%) rotate(45deg)'
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-top ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: '50%'
    },
    transform: 'translateX(-50%) translateY(50%) rotate(45deg)'
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-topLeft ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-topRight ".concat(componentCls, "-arrow"), {
    right: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_componentCls, ["&-placement-bottom ".concat(componentCls, "-arrow"), "&-placement-bottomLeft ".concat(componentCls, "-arrow"), "&-placement-bottomRight ".concat(componentCls, "-arrow")].join(','), {
    top: 0,
    boxShadow: token.boxShadowPopoverArrowBottom,
    transform: "translateY(-50%) rotate(-135deg)"
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-bottom ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: '50%'
    },
    transform: "translateX(-50%) translateY(-50%) rotate(-135deg)"
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-bottomLeft ".concat(componentCls, "-arrow"), {
    left: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-bottomRight ".concat(componentCls, "-arrow"), {
    right: {
      _skip_check_: true,
      value: dropdownArrowOffset
    }
  }), (0, _defineProperty2["default"])(_componentCls, ["&-placement-left ".concat(componentCls, "-arrow"), "&-placement-leftTop ".concat(componentCls, "-arrow"), "&-placement-leftBottom ".concat(componentCls, "-arrow")].join(','), {
    right: {
      _skip_check_: true,
      value: 0
    },
    boxShadow: token.boxShadowPopoverArrow,
    transform: 'translateX(50%) rotate(-45deg)'
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-left ".concat(componentCls, "-arrow"), {
    top: {
      _skip_check_: true,
      value: '50%'
    },
    transform: 'translateY(-50%) translateX(50%) rotate(-45deg)'
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-leftTop ".concat(componentCls, "-arrow"), {
    top: dropdownArrowOffset
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-leftBottom ".concat(componentCls, "-arrow"), {
    bottom: dropdownArrowOffset
  }), (0, _defineProperty2["default"])(_componentCls, ["&-placement-right ".concat(componentCls, "-arrow"), "&-placement-rightTop ".concat(componentCls, "-arrow"), "&-placement-rightBottom ".concat(componentCls, "-arrow")].join(','), {
    left: {
      _skip_check_: true,
      value: 0
    },
    boxShadow: token.boxShadowPopoverArrow,
    transform: 'translateX(-50%) rotate(135deg)'
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-right ".concat(componentCls, "-arrow"), {
    top: {
      _skip_check_: true,
      value: '50%'
    },
    transform: 'translateY(-50%) translateX(-50%) rotate(135deg)'
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-rightTop ".concat(componentCls, "-arrow"), {
    top: dropdownArrowOffset
  }), (0, _defineProperty2["default"])(_componentCls, "&-placement-rightBottom ".concat(componentCls, "-arrow"), {
    bottom: dropdownArrowOffset
  }), (0, _defineProperty2["default"])(_componentCls, connectArrowCls(["&-placement-topLeft", "&-placement-top", "&-placement-topRight"], showArrowCls), {
    paddingBottom: dropdownArrowDistance
  }), (0, _defineProperty2["default"])(_componentCls, connectArrowCls(["&-placement-bottomLeft", "&-placement-bottom", "&-placement-bottomRight"], showArrowCls), {
    paddingTop: dropdownArrowDistance
  }), (0, _defineProperty2["default"])(_componentCls, connectArrowCls(["&-placement-leftTop", "&-placement-left", "&-placement-leftBottom"], showArrowCls), {
    paddingRight: {
      _skip_check_: true,
      value: dropdownArrowDistance
    }
  }), (0, _defineProperty2["default"])(_componentCls, connectArrowCls(["&-placement-rightTop", "&-placement-right", "&-placement-rightBottom"], showArrowCls), {
    paddingLeft: {
      _skip_check_: true,
      value: dropdownArrowDistance
    }
  }), _componentCls));
}