"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _motion = require("../../style/motion");

var _theme = require("../../theme");

var generatorTooltipPresetColor = function generatorTooltipPresetColor(token) {
  var componentCls = token.componentCls;
  return _theme.PresetColors.reduce(function (previousValue, currentValue) {
    var _previousValue$$conc;

    var lightColor = token["".concat(currentValue, "-6")];
    previousValue["&".concat(componentCls, "-").concat(currentValue)] = (_previousValue$$conc = {}, (0, _defineProperty2["default"])(_previousValue$$conc, "".concat(componentCls, "-inner"), {
      backgroundColor: lightColor
    }), (0, _defineProperty2["default"])(_previousValue$$conc, "".concat(componentCls, "-arrow"), {
      background: lightColor,
      '--antd-arrow-background-color': lightColor
    }), _previousValue$$conc);
    return previousValue;
  }, {});
};

var genTooltipStyle = function genTooltipStyle(token) {
  var _extends2;

  var componentCls = token.componentCls,
      tooltipMaxWidth = token.tooltipMaxWidth,
      tooltipColor = token.tooltipColor,
      tooltipBg = token.tooltipBg,
      tooltipBorderRadius = token.tooltipBorderRadius,
      zIndexPopup = token.zIndexPopup,
      controlHeight = token.controlHeight,
      boxShadow = token.boxShadow,
      paddingSM = token.paddingSM,
      paddingXS = token.paddingXS;
  return [(0, _defineProperty2["default"])({}, componentCls, (0, _extends3["default"])((0, _extends3["default"])((0, _extends3["default"])((0, _extends3["default"])({}, (0, _theme.resetComponent)(token)), (_extends2 = {
    position: 'absolute',
    zIndex: zIndexPopup,
    display: 'block',
    '&': [{
      width: 'max-content'
    }, {
      width: 'intrinsic'
    }],
    maxWidth: tooltipMaxWidth,
    visibility: 'visible',
    '&-hidden': {
      display: 'none'
    },
    '--antd-arrow-background-color': tooltipBg
  }, (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-inner"), {
    minWidth: controlHeight,
    minHeight: controlHeight,
    padding: "".concat(paddingSM / 2, "px ").concat(paddingXS, "px"),
    color: tooltipColor,
    textAlign: 'start',
    textDecoration: 'none',
    wordWrap: 'break-word',
    backgroundColor: tooltipBg,
    borderRadius: tooltipBorderRadius,
    boxShadow: boxShadow
  }), (0, _defineProperty2["default"])(_extends2, "".concat(componentCls, "-content"), {
    position: 'relative'
  }), _extends2)), generatorTooltipPresetColor(token)), {
    // RTL
    '&-rtl': {
      direction: 'rtl'
    }
  })), // Arrow Style
  (0, _theme.getArrowStyle)(token, 'var(--antd-arrow-background-color)', '', false)];
}; // ============================== Export ==============================


var _default = function _default(prefixCls, injectStyle) {
  var useOriginHook = (0, _theme.genComponentStyleHook)('Tooltip', function (token) {
    // Popover use Tooltip as internal component. We do not need to handle this.
    if (injectStyle === false) {
      return [];
    }

    var radiusBase = token.radiusBase,
        colorTextLightSolid = token.colorTextLightSolid,
        colorBgDefault = token.colorBgDefault;
    var TooltipToken = (0, _theme.mergeToken)(token, {
      // default variables
      tooltipMaxWidth: 250,
      tooltipColor: colorTextLightSolid,
      tooltipBorderRadius: radiusBase,
      tooltipBg: colorBgDefault
    });
    return [genTooltipStyle(TooltipToken), (0, _motion.initZoomMotion)(token, 'zoom-big-fast')];
  }, function (_ref2) {
    var zIndexPopupBase = _ref2.zIndexPopupBase,
        colorBgTooltipTmp = _ref2.colorBgTooltipTmp;
    return {
      zIndexPopup: zIndexPopupBase + 70,
      colorBgDefault: colorBgTooltipTmp
    };
  });
  return useOriginHook(prefixCls);
};

exports["default"] = _default;